# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class EscalationLevelsPathApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_escalation_level_paths(self, body, escalation_policy_path_id, **kwargs):  # noqa: E501
        """Creates an escalation level for an Escalation Path  # noqa: E501

        Creates a new escalation level from provided data  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_escalation_level_paths(body, escalation_policy_path_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NewEscalationPolicyLevel body: (required)
        :param str escalation_policy_path_id: (required)
        :return: EscalationPolicyLevelResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_escalation_level_paths_with_http_info(body, escalation_policy_path_id, **kwargs)  # noqa: E501
        else:
            (data) = self.create_escalation_level_paths_with_http_info(body, escalation_policy_path_id, **kwargs)  # noqa: E501
            return data

    def create_escalation_level_paths_with_http_info(self, body, escalation_policy_path_id, **kwargs):  # noqa: E501
        """Creates an escalation level for an Escalation Path  # noqa: E501

        Creates a new escalation level from provided data  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_escalation_level_paths_with_http_info(body, escalation_policy_path_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NewEscalationPolicyLevel body: (required)
        :param str escalation_policy_path_id: (required)
        :return: EscalationPolicyLevelResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'escalation_policy_path_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_escalation_level_paths" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_escalation_level_paths`")  # noqa: E501
        # verify the required parameter 'escalation_policy_path_id' is set
        if ('escalation_policy_path_id' not in params or
                params['escalation_policy_path_id'] is None):
            raise ValueError("Missing the required parameter `escalation_policy_path_id` when calling `create_escalation_level_paths`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'escalation_policy_path_id' in params:
            path_params['escalation_policy_path_id'] = params['escalation_policy_path_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/vnd.api+json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/vnd.api+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearer_auth']  # noqa: E501

        return self.api_client.call_api(
            '/v1/escalation_paths/{escalation_policy_path_id}/escalation_levels', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='EscalationPolicyLevelResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_escalation_levels_paths(self, escalation_policy_path_id, **kwargs):  # noqa: E501
        """List escalation levels for an Escalation Path  # noqa: E501

        List escalation levels  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_escalation_levels_paths(escalation_policy_path_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str escalation_policy_path_id: (required)
        :param str include:
        :param int page_number:
        :param int page_size:
        :return: EscalationPolicyLevelList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_escalation_levels_paths_with_http_info(escalation_policy_path_id, **kwargs)  # noqa: E501
        else:
            (data) = self.list_escalation_levels_paths_with_http_info(escalation_policy_path_id, **kwargs)  # noqa: E501
            return data

    def list_escalation_levels_paths_with_http_info(self, escalation_policy_path_id, **kwargs):  # noqa: E501
        """List escalation levels for an Escalation Path  # noqa: E501

        List escalation levels  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_escalation_levels_paths_with_http_info(escalation_policy_path_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str escalation_policy_path_id: (required)
        :param str include:
        :param int page_number:
        :param int page_size:
        :return: EscalationPolicyLevelList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['escalation_policy_path_id', 'include', 'page_number', 'page_size']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_escalation_levels_paths" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'escalation_policy_path_id' is set
        if ('escalation_policy_path_id' not in params or
                params['escalation_policy_path_id'] is None):
            raise ValueError("Missing the required parameter `escalation_policy_path_id` when calling `list_escalation_levels_paths`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'escalation_policy_path_id' in params:
            path_params['escalation_policy_path_id'] = params['escalation_policy_path_id']  # noqa: E501

        query_params = []
        if 'include' in params:
            query_params.append(('include', params['include']))  # noqa: E501
        if 'page_number' in params:
            query_params.append(('page[number]', params['page_number']))  # noqa: E501
        if 'page_size' in params:
            query_params.append(('page[size]', params['page_size']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/vnd.api+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearer_auth']  # noqa: E501

        return self.api_client.call_api(
            '/v1/escalation_paths/{escalation_policy_path_id}/escalation_levels', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='EscalationPolicyLevelList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
