# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AlertsSource(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'alert_urgency_id': 'str',
        'name': 'str',
        'source_type': 'str',
        'status': 'str',
        'secret': 'str',
        'webhook_endpoint': 'str',
        'created_at': 'str',
        'updated_at': 'str',
        'sourceable_attributes': 'object'
    }

    attribute_map = {
        'alert_urgency_id': 'alert_urgency_id',
        'name': 'name',
        'source_type': 'source_type',
        'status': 'status',
        'secret': 'secret',
        'webhook_endpoint': 'webhook_endpoint',
        'created_at': 'created_at',
        'updated_at': 'updated_at',
        'sourceable_attributes': 'sourceable_attributes'
    }

    def __init__(self, alert_urgency_id=None, name=None, source_type=None, status=None, secret=None, webhook_endpoint=None, created_at=None, updated_at=None, sourceable_attributes=None):  # noqa: E501
        """AlertsSource - a model defined in Swagger"""  # noqa: E501
        self._alert_urgency_id = None
        self._name = None
        self._source_type = None
        self._status = None
        self._secret = None
        self._webhook_endpoint = None
        self._created_at = None
        self._updated_at = None
        self._sourceable_attributes = None
        self.discriminator = None
        if alert_urgency_id is not None:
            self.alert_urgency_id = alert_urgency_id
        self.name = name
        if source_type is not None:
            self.source_type = source_type
        self.status = status
        self.secret = secret
        self.webhook_endpoint = webhook_endpoint
        self.created_at = created_at
        self.updated_at = updated_at
        if sourceable_attributes is not None:
            self.sourceable_attributes = sourceable_attributes

    @property
    def alert_urgency_id(self):
        """Gets the alert_urgency_id of this AlertsSource.  # noqa: E501

        ID for the default alert urgency assigned to this alert source  # noqa: E501

        :return: The alert_urgency_id of this AlertsSource.  # noqa: E501
        :rtype: str
        """
        return self._alert_urgency_id

    @alert_urgency_id.setter
    def alert_urgency_id(self, alert_urgency_id):
        """Sets the alert_urgency_id of this AlertsSource.

        ID for the default alert urgency assigned to this alert source  # noqa: E501

        :param alert_urgency_id: The alert_urgency_id of this AlertsSource.  # noqa: E501
        :type: str
        """

        self._alert_urgency_id = alert_urgency_id

    @property
    def name(self):
        """Gets the name of this AlertsSource.  # noqa: E501

        The name of the alert source  # noqa: E501

        :return: The name of this AlertsSource.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this AlertsSource.

        The name of the alert source  # noqa: E501

        :param name: The name of this AlertsSource.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def source_type(self):
        """Gets the source_type of this AlertsSource.  # noqa: E501

        The alert source type  # noqa: E501

        :return: The source_type of this AlertsSource.  # noqa: E501
        :rtype: str
        """
        return self._source_type

    @source_type.setter
    def source_type(self, source_type):
        """Sets the source_type of this AlertsSource.

        The alert source type  # noqa: E501

        :param source_type: The source_type of this AlertsSource.  # noqa: E501
        :type: str
        """

        self._source_type = source_type

    @property
    def status(self):
        """Gets the status of this AlertsSource.  # noqa: E501

        The current status of the alert source  # noqa: E501

        :return: The status of this AlertsSource.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this AlertsSource.

        The current status of the alert source  # noqa: E501

        :param status: The status of this AlertsSource.  # noqa: E501
        :type: str
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    @property
    def secret(self):
        """Gets the secret of this AlertsSource.  # noqa: E501

        A secret key used to authenticate incoming requests to this alerts source  # noqa: E501

        :return: The secret of this AlertsSource.  # noqa: E501
        :rtype: str
        """
        return self._secret

    @secret.setter
    def secret(self, secret):
        """Sets the secret of this AlertsSource.

        A secret key used to authenticate incoming requests to this alerts source  # noqa: E501

        :param secret: The secret of this AlertsSource.  # noqa: E501
        :type: str
        """
        if secret is None:
            raise ValueError("Invalid value for `secret`, must not be `None`")  # noqa: E501

        self._secret = secret

    @property
    def webhook_endpoint(self):
        """Gets the webhook_endpoint of this AlertsSource.  # noqa: E501

        The URL endpoint of the alert source  # noqa: E501

        :return: The webhook_endpoint of this AlertsSource.  # noqa: E501
        :rtype: str
        """
        return self._webhook_endpoint

    @webhook_endpoint.setter
    def webhook_endpoint(self, webhook_endpoint):
        """Sets the webhook_endpoint of this AlertsSource.

        The URL endpoint of the alert source  # noqa: E501

        :param webhook_endpoint: The webhook_endpoint of this AlertsSource.  # noqa: E501
        :type: str
        """
        if webhook_endpoint is None:
            raise ValueError("Invalid value for `webhook_endpoint`, must not be `None`")  # noqa: E501

        self._webhook_endpoint = webhook_endpoint

    @property
    def created_at(self):
        """Gets the created_at of this AlertsSource.  # noqa: E501

        Date of creation  # noqa: E501

        :return: The created_at of this AlertsSource.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this AlertsSource.

        Date of creation  # noqa: E501

        :param created_at: The created_at of this AlertsSource.  # noqa: E501
        :type: str
        """
        if created_at is None:
            raise ValueError("Invalid value for `created_at`, must not be `None`")  # noqa: E501

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this AlertsSource.  # noqa: E501

        Date of last update  # noqa: E501

        :return: The updated_at of this AlertsSource.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this AlertsSource.

        Date of last update  # noqa: E501

        :param updated_at: The updated_at of this AlertsSource.  # noqa: E501
        :type: str
        """
        if updated_at is None:
            raise ValueError("Invalid value for `updated_at`, must not be `None`")  # noqa: E501

        self._updated_at = updated_at

    @property
    def sourceable_attributes(self):
        """Gets the sourceable_attributes of this AlertsSource.  # noqa: E501

        Additional attributes specific to certain alert sources (e.g., generic_webhook), encapsulating source-specific configurations or details  # noqa: E501

        :return: The sourceable_attributes of this AlertsSource.  # noqa: E501
        :rtype: object
        """
        return self._sourceable_attributes

    @sourceable_attributes.setter
    def sourceable_attributes(self, sourceable_attributes):
        """Sets the sourceable_attributes of this AlertsSource.

        Additional attributes specific to certain alert sources (e.g., generic_webhook), encapsulating source-specific configurations or details  # noqa: E501

        :param sourceable_attributes: The sourceable_attributes of this AlertsSource.  # noqa: E501
        :type: object
        """

        self._sourceable_attributes = sourceable_attributes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AlertsSource, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AlertsSource):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
