# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateAsanaTaskTaskParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'task_type': 'str',
        'workspace': 'AddActionItemTaskParamsPostToSlackChannels',
        'projects': 'list[AddActionItemTaskParamsPostToSlackChannels]',
        'title': 'str',
        'notes': 'str',
        'assign_user_email': 'str',
        'completion': 'AddActionItemTaskParamsPostToSlackChannels',
        'due_date': 'str',
        'custom_fields_mapping': 'str',
        'dependency_direction': 'str',
        'dependent_task_ids': 'list[str]'
    }

    attribute_map = {
        'task_type': 'task_type',
        'workspace': 'workspace',
        'projects': 'projects',
        'title': 'title',
        'notes': 'notes',
        'assign_user_email': 'assign_user_email',
        'completion': 'completion',
        'due_date': 'due_date',
        'custom_fields_mapping': 'custom_fields_mapping',
        'dependency_direction': 'dependency_direction',
        'dependent_task_ids': 'dependent_task_ids'
    }

    def __init__(self, task_type=None, workspace=None, projects=None, title=None, notes=None, assign_user_email=None, completion=None, due_date=None, custom_fields_mapping=None, dependency_direction='blocking', dependent_task_ids=None):  # noqa: E501
        """CreateAsanaTaskTaskParams - a model defined in Swagger"""  # noqa: E501
        self._task_type = None
        self._workspace = None
        self._projects = None
        self._title = None
        self._notes = None
        self._assign_user_email = None
        self._completion = None
        self._due_date = None
        self._custom_fields_mapping = None
        self._dependency_direction = None
        self._dependent_task_ids = None
        self.discriminator = None
        if task_type is not None:
            self.task_type = task_type
        self.workspace = workspace
        self.projects = projects
        self.title = title
        if notes is not None:
            self.notes = notes
        if assign_user_email is not None:
            self.assign_user_email = assign_user_email
        self.completion = completion
        if due_date is not None:
            self.due_date = due_date
        if custom_fields_mapping is not None:
            self.custom_fields_mapping = custom_fields_mapping
        if dependency_direction is not None:
            self.dependency_direction = dependency_direction
        if dependent_task_ids is not None:
            self.dependent_task_ids = dependent_task_ids

    @property
    def task_type(self):
        """Gets the task_type of this CreateAsanaTaskTaskParams.  # noqa: E501


        :return: The task_type of this CreateAsanaTaskTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._task_type

    @task_type.setter
    def task_type(self, task_type):
        """Sets the task_type of this CreateAsanaTaskTaskParams.


        :param task_type: The task_type of this CreateAsanaTaskTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["create_asana_task"]  # noqa: E501
        if task_type not in allowed_values:
            raise ValueError(
                "Invalid value for `task_type` ({0}), must be one of {1}"  # noqa: E501
                .format(task_type, allowed_values)
            )

        self._task_type = task_type

    @property
    def workspace(self):
        """Gets the workspace of this CreateAsanaTaskTaskParams.  # noqa: E501


        :return: The workspace of this CreateAsanaTaskTaskParams.  # noqa: E501
        :rtype: AddActionItemTaskParamsPostToSlackChannels
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this CreateAsanaTaskTaskParams.


        :param workspace: The workspace of this CreateAsanaTaskTaskParams.  # noqa: E501
        :type: AddActionItemTaskParamsPostToSlackChannels
        """
        if workspace is None:
            raise ValueError("Invalid value for `workspace`, must not be `None`")  # noqa: E501

        self._workspace = workspace

    @property
    def projects(self):
        """Gets the projects of this CreateAsanaTaskTaskParams.  # noqa: E501


        :return: The projects of this CreateAsanaTaskTaskParams.  # noqa: E501
        :rtype: list[AddActionItemTaskParamsPostToSlackChannels]
        """
        return self._projects

    @projects.setter
    def projects(self, projects):
        """Sets the projects of this CreateAsanaTaskTaskParams.


        :param projects: The projects of this CreateAsanaTaskTaskParams.  # noqa: E501
        :type: list[AddActionItemTaskParamsPostToSlackChannels]
        """
        if projects is None:
            raise ValueError("Invalid value for `projects`, must not be `None`")  # noqa: E501

        self._projects = projects

    @property
    def title(self):
        """Gets the title of this CreateAsanaTaskTaskParams.  # noqa: E501

        The task title  # noqa: E501

        :return: The title of this CreateAsanaTaskTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this CreateAsanaTaskTaskParams.

        The task title  # noqa: E501

        :param title: The title of this CreateAsanaTaskTaskParams.  # noqa: E501
        :type: str
        """
        if title is None:
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def notes(self):
        """Gets the notes of this CreateAsanaTaskTaskParams.  # noqa: E501


        :return: The notes of this CreateAsanaTaskTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._notes

    @notes.setter
    def notes(self, notes):
        """Sets the notes of this CreateAsanaTaskTaskParams.


        :param notes: The notes of this CreateAsanaTaskTaskParams.  # noqa: E501
        :type: str
        """

        self._notes = notes

    @property
    def assign_user_email(self):
        """Gets the assign_user_email of this CreateAsanaTaskTaskParams.  # noqa: E501

        The assigned user's email  # noqa: E501

        :return: The assign_user_email of this CreateAsanaTaskTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._assign_user_email

    @assign_user_email.setter
    def assign_user_email(self, assign_user_email):
        """Sets the assign_user_email of this CreateAsanaTaskTaskParams.

        The assigned user's email  # noqa: E501

        :param assign_user_email: The assign_user_email of this CreateAsanaTaskTaskParams.  # noqa: E501
        :type: str
        """

        self._assign_user_email = assign_user_email

    @property
    def completion(self):
        """Gets the completion of this CreateAsanaTaskTaskParams.  # noqa: E501


        :return: The completion of this CreateAsanaTaskTaskParams.  # noqa: E501
        :rtype: AddActionItemTaskParamsPostToSlackChannels
        """
        return self._completion

    @completion.setter
    def completion(self, completion):
        """Sets the completion of this CreateAsanaTaskTaskParams.


        :param completion: The completion of this CreateAsanaTaskTaskParams.  # noqa: E501
        :type: AddActionItemTaskParamsPostToSlackChannels
        """
        if completion is None:
            raise ValueError("Invalid value for `completion`, must not be `None`")  # noqa: E501

        self._completion = completion

    @property
    def due_date(self):
        """Gets the due_date of this CreateAsanaTaskTaskParams.  # noqa: E501

        The due date  # noqa: E501

        :return: The due_date of this CreateAsanaTaskTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._due_date

    @due_date.setter
    def due_date(self, due_date):
        """Sets the due_date of this CreateAsanaTaskTaskParams.

        The due date  # noqa: E501

        :param due_date: The due_date of this CreateAsanaTaskTaskParams.  # noqa: E501
        :type: str
        """

        self._due_date = due_date

    @property
    def custom_fields_mapping(self):
        """Gets the custom_fields_mapping of this CreateAsanaTaskTaskParams.  # noqa: E501

        Custom field mappings. Can contain liquid markup and need to be valid JSON  # noqa: E501

        :return: The custom_fields_mapping of this CreateAsanaTaskTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._custom_fields_mapping

    @custom_fields_mapping.setter
    def custom_fields_mapping(self, custom_fields_mapping):
        """Sets the custom_fields_mapping of this CreateAsanaTaskTaskParams.

        Custom field mappings. Can contain liquid markup and need to be valid JSON  # noqa: E501

        :param custom_fields_mapping: The custom_fields_mapping of this CreateAsanaTaskTaskParams.  # noqa: E501
        :type: str
        """

        self._custom_fields_mapping = custom_fields_mapping

    @property
    def dependency_direction(self):
        """Gets the dependency_direction of this CreateAsanaTaskTaskParams.  # noqa: E501


        :return: The dependency_direction of this CreateAsanaTaskTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._dependency_direction

    @dependency_direction.setter
    def dependency_direction(self, dependency_direction):
        """Sets the dependency_direction of this CreateAsanaTaskTaskParams.


        :param dependency_direction: The dependency_direction of this CreateAsanaTaskTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["blocking", "blocked_by"]  # noqa: E501
        if dependency_direction not in allowed_values:
            raise ValueError(
                "Invalid value for `dependency_direction` ({0}), must be one of {1}"  # noqa: E501
                .format(dependency_direction, allowed_values)
            )

        self._dependency_direction = dependency_direction

    @property
    def dependent_task_ids(self):
        """Gets the dependent_task_ids of this CreateAsanaTaskTaskParams.  # noqa: E501

        Dependent task ids. Supports liquid syntax  # noqa: E501

        :return: The dependent_task_ids of this CreateAsanaTaskTaskParams.  # noqa: E501
        :rtype: list[str]
        """
        return self._dependent_task_ids

    @dependent_task_ids.setter
    def dependent_task_ids(self, dependent_task_ids):
        """Sets the dependent_task_ids of this CreateAsanaTaskTaskParams.

        Dependent task ids. Supports liquid syntax  # noqa: E501

        :param dependent_task_ids: The dependent_task_ids of this CreateAsanaTaskTaskParams.  # noqa: E501
        :type: list[str]
        """

        self._dependent_task_ids = dependent_task_ids

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateAsanaTaskTaskParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateAsanaTaskTaskParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
