# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateGoToMeetingTaskParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'task_type': 'str',
        'subject': 'str',
        'conference_call_info': 'str',
        'password_required': 'bool',
        'post_to_incident_timeline': 'bool',
        'post_to_slack_channels': 'list[AddActionItemTaskParamsPostToSlackChannels]'
    }

    attribute_map = {
        'task_type': 'task_type',
        'subject': 'subject',
        'conference_call_info': 'conference_call_info',
        'password_required': 'password_required',
        'post_to_incident_timeline': 'post_to_incident_timeline',
        'post_to_slack_channels': 'post_to_slack_channels'
    }

    def __init__(self, task_type=None, subject=None, conference_call_info='voip', password_required=None, post_to_incident_timeline=None, post_to_slack_channels=None):  # noqa: E501
        """CreateGoToMeetingTaskParams - a model defined in Swagger"""  # noqa: E501
        self._task_type = None
        self._subject = None
        self._conference_call_info = None
        self._password_required = None
        self._post_to_incident_timeline = None
        self._post_to_slack_channels = None
        self.discriminator = None
        if task_type is not None:
            self.task_type = task_type
        self.subject = subject
        if conference_call_info is not None:
            self.conference_call_info = conference_call_info
        if password_required is not None:
            self.password_required = password_required
        if post_to_incident_timeline is not None:
            self.post_to_incident_timeline = post_to_incident_timeline
        if post_to_slack_channels is not None:
            self.post_to_slack_channels = post_to_slack_channels

    @property
    def task_type(self):
        """Gets the task_type of this CreateGoToMeetingTaskParams.  # noqa: E501


        :return: The task_type of this CreateGoToMeetingTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._task_type

    @task_type.setter
    def task_type(self, task_type):
        """Sets the task_type of this CreateGoToMeetingTaskParams.


        :param task_type: The task_type of this CreateGoToMeetingTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["create_go_to_meeting_task"]  # noqa: E501
        if task_type not in allowed_values:
            raise ValueError(
                "Invalid value for `task_type` ({0}), must be one of {1}"  # noqa: E501
                .format(task_type, allowed_values)
            )

        self._task_type = task_type

    @property
    def subject(self):
        """Gets the subject of this CreateGoToMeetingTaskParams.  # noqa: E501

        The meeting subject  # noqa: E501

        :return: The subject of this CreateGoToMeetingTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._subject

    @subject.setter
    def subject(self, subject):
        """Sets the subject of this CreateGoToMeetingTaskParams.

        The meeting subject  # noqa: E501

        :param subject: The subject of this CreateGoToMeetingTaskParams.  # noqa: E501
        :type: str
        """
        if subject is None:
            raise ValueError("Invalid value for `subject`, must not be `None`")  # noqa: E501

        self._subject = subject

    @property
    def conference_call_info(self):
        """Gets the conference_call_info of this CreateGoToMeetingTaskParams.  # noqa: E501


        :return: The conference_call_info of this CreateGoToMeetingTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._conference_call_info

    @conference_call_info.setter
    def conference_call_info(self, conference_call_info):
        """Sets the conference_call_info of this CreateGoToMeetingTaskParams.


        :param conference_call_info: The conference_call_info of this CreateGoToMeetingTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["ptsn", "free", "hyrid", "voip"]  # noqa: E501
        if conference_call_info not in allowed_values:
            raise ValueError(
                "Invalid value for `conference_call_info` ({0}), must be one of {1}"  # noqa: E501
                .format(conference_call_info, allowed_values)
            )

        self._conference_call_info = conference_call_info

    @property
    def password_required(self):
        """Gets the password_required of this CreateGoToMeetingTaskParams.  # noqa: E501


        :return: The password_required of this CreateGoToMeetingTaskParams.  # noqa: E501
        :rtype: bool
        """
        return self._password_required

    @password_required.setter
    def password_required(self, password_required):
        """Sets the password_required of this CreateGoToMeetingTaskParams.


        :param password_required: The password_required of this CreateGoToMeetingTaskParams.  # noqa: E501
        :type: bool
        """

        self._password_required = password_required

    @property
    def post_to_incident_timeline(self):
        """Gets the post_to_incident_timeline of this CreateGoToMeetingTaskParams.  # noqa: E501


        :return: The post_to_incident_timeline of this CreateGoToMeetingTaskParams.  # noqa: E501
        :rtype: bool
        """
        return self._post_to_incident_timeline

    @post_to_incident_timeline.setter
    def post_to_incident_timeline(self, post_to_incident_timeline):
        """Sets the post_to_incident_timeline of this CreateGoToMeetingTaskParams.


        :param post_to_incident_timeline: The post_to_incident_timeline of this CreateGoToMeetingTaskParams.  # noqa: E501
        :type: bool
        """

        self._post_to_incident_timeline = post_to_incident_timeline

    @property
    def post_to_slack_channels(self):
        """Gets the post_to_slack_channels of this CreateGoToMeetingTaskParams.  # noqa: E501


        :return: The post_to_slack_channels of this CreateGoToMeetingTaskParams.  # noqa: E501
        :rtype: list[AddActionItemTaskParamsPostToSlackChannels]
        """
        return self._post_to_slack_channels

    @post_to_slack_channels.setter
    def post_to_slack_channels(self, post_to_slack_channels):
        """Sets the post_to_slack_channels of this CreateGoToMeetingTaskParams.


        :param post_to_slack_channels: The post_to_slack_channels of this CreateGoToMeetingTaskParams.  # noqa: E501
        :type: list[AddActionItemTaskParamsPostToSlackChannels]
        """

        self._post_to_slack_channels = post_to_slack_channels

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateGoToMeetingTaskParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateGoToMeetingTaskParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
