# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateGoogleDocsPermissionsTaskParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'task_type': 'str',
        'file_id': 'str',
        'permissions': 'str',
        'send_notification_email': 'bool',
        'email_message': 'str'
    }

    attribute_map = {
        'task_type': 'task_type',
        'file_id': 'file_id',
        'permissions': 'permissions',
        'send_notification_email': 'send_notification_email',
        'email_message': 'email_message'
    }

    def __init__(self, task_type=None, file_id=None, permissions=None, send_notification_email=None, email_message=None):  # noqa: E501
        """CreateGoogleDocsPermissionsTaskParams - a model defined in Swagger"""  # noqa: E501
        self._task_type = None
        self._file_id = None
        self._permissions = None
        self._send_notification_email = None
        self._email_message = None
        self.discriminator = None
        if task_type is not None:
            self.task_type = task_type
        self.file_id = file_id
        self.permissions = permissions
        if send_notification_email is not None:
            self.send_notification_email = send_notification_email
        if email_message is not None:
            self.email_message = email_message

    @property
    def task_type(self):
        """Gets the task_type of this CreateGoogleDocsPermissionsTaskParams.  # noqa: E501


        :return: The task_type of this CreateGoogleDocsPermissionsTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._task_type

    @task_type.setter
    def task_type(self, task_type):
        """Sets the task_type of this CreateGoogleDocsPermissionsTaskParams.


        :param task_type: The task_type of this CreateGoogleDocsPermissionsTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["create_google_docs_permissions"]  # noqa: E501
        if task_type not in allowed_values:
            raise ValueError(
                "Invalid value for `task_type` ({0}), must be one of {1}"  # noqa: E501
                .format(task_type, allowed_values)
            )

        self._task_type = task_type

    @property
    def file_id(self):
        """Gets the file_id of this CreateGoogleDocsPermissionsTaskParams.  # noqa: E501

        The Google Doc file ID  # noqa: E501

        :return: The file_id of this CreateGoogleDocsPermissionsTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._file_id

    @file_id.setter
    def file_id(self, file_id):
        """Sets the file_id of this CreateGoogleDocsPermissionsTaskParams.

        The Google Doc file ID  # noqa: E501

        :param file_id: The file_id of this CreateGoogleDocsPermissionsTaskParams.  # noqa: E501
        :type: str
        """
        if file_id is None:
            raise ValueError("Invalid value for `file_id`, must not be `None`")  # noqa: E501

        self._file_id = file_id

    @property
    def permissions(self):
        """Gets the permissions of this CreateGoogleDocsPermissionsTaskParams.  # noqa: E501

        Page permissions JSON  # noqa: E501

        :return: The permissions of this CreateGoogleDocsPermissionsTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._permissions

    @permissions.setter
    def permissions(self, permissions):
        """Sets the permissions of this CreateGoogleDocsPermissionsTaskParams.

        Page permissions JSON  # noqa: E501

        :param permissions: The permissions of this CreateGoogleDocsPermissionsTaskParams.  # noqa: E501
        :type: str
        """
        if permissions is None:
            raise ValueError("Invalid value for `permissions`, must not be `None`")  # noqa: E501

        self._permissions = permissions

    @property
    def send_notification_email(self):
        """Gets the send_notification_email of this CreateGoogleDocsPermissionsTaskParams.  # noqa: E501


        :return: The send_notification_email of this CreateGoogleDocsPermissionsTaskParams.  # noqa: E501
        :rtype: bool
        """
        return self._send_notification_email

    @send_notification_email.setter
    def send_notification_email(self, send_notification_email):
        """Sets the send_notification_email of this CreateGoogleDocsPermissionsTaskParams.


        :param send_notification_email: The send_notification_email of this CreateGoogleDocsPermissionsTaskParams.  # noqa: E501
        :type: bool
        """

        self._send_notification_email = send_notification_email

    @property
    def email_message(self):
        """Gets the email_message of this CreateGoogleDocsPermissionsTaskParams.  # noqa: E501

        Email message notification  # noqa: E501

        :return: The email_message of this CreateGoogleDocsPermissionsTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._email_message

    @email_message.setter
    def email_message(self, email_message):
        """Sets the email_message of this CreateGoogleDocsPermissionsTaskParams.

        Email message notification  # noqa: E501

        :param email_message: The email_message of this CreateGoogleDocsPermissionsTaskParams.  # noqa: E501
        :type: str
        """

        self._email_message = email_message

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateGoogleDocsPermissionsTaskParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateGoogleDocsPermissionsTaskParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
