# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateIncidentTaskParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'task_type': 'str',
        'title': 'str',
        'summary': 'str',
        'severity_id': 'str',
        'incident_type_ids': 'list[str]',
        'service_ids': 'list[str]',
        'functionality_ids': 'list[str]',
        'environment_ids': 'list[str]',
        'group_ids': 'list[str]',
        'private': 'bool',
        'custom_fields_mapping': 'str'
    }

    attribute_map = {
        'task_type': 'task_type',
        'title': 'title',
        'summary': 'summary',
        'severity_id': 'severity_id',
        'incident_type_ids': 'incident_type_ids',
        'service_ids': 'service_ids',
        'functionality_ids': 'functionality_ids',
        'environment_ids': 'environment_ids',
        'group_ids': 'group_ids',
        'private': 'private',
        'custom_fields_mapping': 'custom_fields_mapping'
    }

    def __init__(self, task_type=None, title=None, summary=None, severity_id=None, incident_type_ids=None, service_ids=None, functionality_ids=None, environment_ids=None, group_ids=None, private=None, custom_fields_mapping=None):  # noqa: E501
        """CreateIncidentTaskParams - a model defined in Swagger"""  # noqa: E501
        self._task_type = None
        self._title = None
        self._summary = None
        self._severity_id = None
        self._incident_type_ids = None
        self._service_ids = None
        self._functionality_ids = None
        self._environment_ids = None
        self._group_ids = None
        self._private = None
        self._custom_fields_mapping = None
        self.discriminator = None
        if task_type is not None:
            self.task_type = task_type
        self.title = title
        if summary is not None:
            self.summary = summary
        if severity_id is not None:
            self.severity_id = severity_id
        if incident_type_ids is not None:
            self.incident_type_ids = incident_type_ids
        if service_ids is not None:
            self.service_ids = service_ids
        if functionality_ids is not None:
            self.functionality_ids = functionality_ids
        if environment_ids is not None:
            self.environment_ids = environment_ids
        if group_ids is not None:
            self.group_ids = group_ids
        if private is not None:
            self.private = private
        if custom_fields_mapping is not None:
            self.custom_fields_mapping = custom_fields_mapping

    @property
    def task_type(self):
        """Gets the task_type of this CreateIncidentTaskParams.  # noqa: E501


        :return: The task_type of this CreateIncidentTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._task_type

    @task_type.setter
    def task_type(self, task_type):
        """Sets the task_type of this CreateIncidentTaskParams.


        :param task_type: The task_type of this CreateIncidentTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["create_incident"]  # noqa: E501
        if task_type not in allowed_values:
            raise ValueError(
                "Invalid value for `task_type` ({0}), must be one of {1}"  # noqa: E501
                .format(task_type, allowed_values)
            )

        self._task_type = task_type

    @property
    def title(self):
        """Gets the title of this CreateIncidentTaskParams.  # noqa: E501

        The incident title  # noqa: E501

        :return: The title of this CreateIncidentTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this CreateIncidentTaskParams.

        The incident title  # noqa: E501

        :param title: The title of this CreateIncidentTaskParams.  # noqa: E501
        :type: str
        """
        if title is None:
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def summary(self):
        """Gets the summary of this CreateIncidentTaskParams.  # noqa: E501

        The incident summary  # noqa: E501

        :return: The summary of this CreateIncidentTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._summary

    @summary.setter
    def summary(self, summary):
        """Sets the summary of this CreateIncidentTaskParams.

        The incident summary  # noqa: E501

        :param summary: The summary of this CreateIncidentTaskParams.  # noqa: E501
        :type: str
        """

        self._summary = summary

    @property
    def severity_id(self):
        """Gets the severity_id of this CreateIncidentTaskParams.  # noqa: E501


        :return: The severity_id of this CreateIncidentTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._severity_id

    @severity_id.setter
    def severity_id(self, severity_id):
        """Sets the severity_id of this CreateIncidentTaskParams.


        :param severity_id: The severity_id of this CreateIncidentTaskParams.  # noqa: E501
        :type: str
        """

        self._severity_id = severity_id

    @property
    def incident_type_ids(self):
        """Gets the incident_type_ids of this CreateIncidentTaskParams.  # noqa: E501


        :return: The incident_type_ids of this CreateIncidentTaskParams.  # noqa: E501
        :rtype: list[str]
        """
        return self._incident_type_ids

    @incident_type_ids.setter
    def incident_type_ids(self, incident_type_ids):
        """Sets the incident_type_ids of this CreateIncidentTaskParams.


        :param incident_type_ids: The incident_type_ids of this CreateIncidentTaskParams.  # noqa: E501
        :type: list[str]
        """

        self._incident_type_ids = incident_type_ids

    @property
    def service_ids(self):
        """Gets the service_ids of this CreateIncidentTaskParams.  # noqa: E501


        :return: The service_ids of this CreateIncidentTaskParams.  # noqa: E501
        :rtype: list[str]
        """
        return self._service_ids

    @service_ids.setter
    def service_ids(self, service_ids):
        """Sets the service_ids of this CreateIncidentTaskParams.


        :param service_ids: The service_ids of this CreateIncidentTaskParams.  # noqa: E501
        :type: list[str]
        """

        self._service_ids = service_ids

    @property
    def functionality_ids(self):
        """Gets the functionality_ids of this CreateIncidentTaskParams.  # noqa: E501


        :return: The functionality_ids of this CreateIncidentTaskParams.  # noqa: E501
        :rtype: list[str]
        """
        return self._functionality_ids

    @functionality_ids.setter
    def functionality_ids(self, functionality_ids):
        """Sets the functionality_ids of this CreateIncidentTaskParams.


        :param functionality_ids: The functionality_ids of this CreateIncidentTaskParams.  # noqa: E501
        :type: list[str]
        """

        self._functionality_ids = functionality_ids

    @property
    def environment_ids(self):
        """Gets the environment_ids of this CreateIncidentTaskParams.  # noqa: E501


        :return: The environment_ids of this CreateIncidentTaskParams.  # noqa: E501
        :rtype: list[str]
        """
        return self._environment_ids

    @environment_ids.setter
    def environment_ids(self, environment_ids):
        """Sets the environment_ids of this CreateIncidentTaskParams.


        :param environment_ids: The environment_ids of this CreateIncidentTaskParams.  # noqa: E501
        :type: list[str]
        """

        self._environment_ids = environment_ids

    @property
    def group_ids(self):
        """Gets the group_ids of this CreateIncidentTaskParams.  # noqa: E501


        :return: The group_ids of this CreateIncidentTaskParams.  # noqa: E501
        :rtype: list[str]
        """
        return self._group_ids

    @group_ids.setter
    def group_ids(self, group_ids):
        """Sets the group_ids of this CreateIncidentTaskParams.


        :param group_ids: The group_ids of this CreateIncidentTaskParams.  # noqa: E501
        :type: list[str]
        """

        self._group_ids = group_ids

    @property
    def private(self):
        """Gets the private of this CreateIncidentTaskParams.  # noqa: E501


        :return: The private of this CreateIncidentTaskParams.  # noqa: E501
        :rtype: bool
        """
        return self._private

    @private.setter
    def private(self, private):
        """Sets the private of this CreateIncidentTaskParams.


        :param private: The private of this CreateIncidentTaskParams.  # noqa: E501
        :type: bool
        """

        self._private = private

    @property
    def custom_fields_mapping(self):
        """Gets the custom_fields_mapping of this CreateIncidentTaskParams.  # noqa: E501

        Custom field mappings. Can contain liquid markup and need to be valid JSON  # noqa: E501

        :return: The custom_fields_mapping of this CreateIncidentTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._custom_fields_mapping

    @custom_fields_mapping.setter
    def custom_fields_mapping(self, custom_fields_mapping):
        """Sets the custom_fields_mapping of this CreateIncidentTaskParams.

        Custom field mappings. Can contain liquid markup and need to be valid JSON  # noqa: E501

        :param custom_fields_mapping: The custom_fields_mapping of this CreateIncidentTaskParams.  # noqa: E501
        :type: str
        """

        self._custom_fields_mapping = custom_fields_mapping

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateIncidentTaskParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateIncidentTaskParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
