# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateOutlookEventTaskParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'task_type': 'str',
        'calendar': 'AddActionItemTaskParamsPostToSlackChannels',
        'attendees': 'list[str]',
        'time_zone': 'str',
        'days_until_meeting': 'int',
        'time_of_meeting': 'str',
        'meeting_duration': 'str',
        'summary': 'str',
        'description': 'str',
        'exclude_weekends': 'bool',
        'post_to_incident_timeline': 'bool',
        'post_to_slack_channels': 'list[AddActionItemTaskParamsPostToSlackChannels]'
    }

    attribute_map = {
        'task_type': 'task_type',
        'calendar': 'calendar',
        'attendees': 'attendees',
        'time_zone': 'time_zone',
        'days_until_meeting': 'days_until_meeting',
        'time_of_meeting': 'time_of_meeting',
        'meeting_duration': 'meeting_duration',
        'summary': 'summary',
        'description': 'description',
        'exclude_weekends': 'exclude_weekends',
        'post_to_incident_timeline': 'post_to_incident_timeline',
        'post_to_slack_channels': 'post_to_slack_channels'
    }

    def __init__(self, task_type=None, calendar=None, attendees=None, time_zone=None, days_until_meeting=None, time_of_meeting=None, meeting_duration=None, summary=None, description=None, exclude_weekends=None, post_to_incident_timeline=None, post_to_slack_channels=None):  # noqa: E501
        """CreateOutlookEventTaskParams - a model defined in Swagger"""  # noqa: E501
        self._task_type = None
        self._calendar = None
        self._attendees = None
        self._time_zone = None
        self._days_until_meeting = None
        self._time_of_meeting = None
        self._meeting_duration = None
        self._summary = None
        self._description = None
        self._exclude_weekends = None
        self._post_to_incident_timeline = None
        self._post_to_slack_channels = None
        self.discriminator = None
        if task_type is not None:
            self.task_type = task_type
        self.calendar = calendar
        if attendees is not None:
            self.attendees = attendees
        if time_zone is not None:
            self.time_zone = time_zone
        self.days_until_meeting = days_until_meeting
        self.time_of_meeting = time_of_meeting
        self.meeting_duration = meeting_duration
        self.summary = summary
        self.description = description
        if exclude_weekends is not None:
            self.exclude_weekends = exclude_weekends
        if post_to_incident_timeline is not None:
            self.post_to_incident_timeline = post_to_incident_timeline
        if post_to_slack_channels is not None:
            self.post_to_slack_channels = post_to_slack_channels

    @property
    def task_type(self):
        """Gets the task_type of this CreateOutlookEventTaskParams.  # noqa: E501


        :return: The task_type of this CreateOutlookEventTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._task_type

    @task_type.setter
    def task_type(self, task_type):
        """Sets the task_type of this CreateOutlookEventTaskParams.


        :param task_type: The task_type of this CreateOutlookEventTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["create_outlook_event"]  # noqa: E501
        if task_type not in allowed_values:
            raise ValueError(
                "Invalid value for `task_type` ({0}), must be one of {1}"  # noqa: E501
                .format(task_type, allowed_values)
            )

        self._task_type = task_type

    @property
    def calendar(self):
        """Gets the calendar of this CreateOutlookEventTaskParams.  # noqa: E501


        :return: The calendar of this CreateOutlookEventTaskParams.  # noqa: E501
        :rtype: AddActionItemTaskParamsPostToSlackChannels
        """
        return self._calendar

    @calendar.setter
    def calendar(self, calendar):
        """Sets the calendar of this CreateOutlookEventTaskParams.


        :param calendar: The calendar of this CreateOutlookEventTaskParams.  # noqa: E501
        :type: AddActionItemTaskParamsPostToSlackChannels
        """
        if calendar is None:
            raise ValueError("Invalid value for `calendar`, must not be `None`")  # noqa: E501

        self._calendar = calendar

    @property
    def attendees(self):
        """Gets the attendees of this CreateOutlookEventTaskParams.  # noqa: E501

        Emails of attendees  # noqa: E501

        :return: The attendees of this CreateOutlookEventTaskParams.  # noqa: E501
        :rtype: list[str]
        """
        return self._attendees

    @attendees.setter
    def attendees(self, attendees):
        """Sets the attendees of this CreateOutlookEventTaskParams.

        Emails of attendees  # noqa: E501

        :param attendees: The attendees of this CreateOutlookEventTaskParams.  # noqa: E501
        :type: list[str]
        """

        self._attendees = attendees

    @property
    def time_zone(self):
        """Gets the time_zone of this CreateOutlookEventTaskParams.  # noqa: E501

        A valid IANA time zone name.  # noqa: E501

        :return: The time_zone of this CreateOutlookEventTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._time_zone

    @time_zone.setter
    def time_zone(self, time_zone):
        """Sets the time_zone of this CreateOutlookEventTaskParams.

        A valid IANA time zone name.  # noqa: E501

        :param time_zone: The time_zone of this CreateOutlookEventTaskParams.  # noqa: E501
        :type: str
        """

        self._time_zone = time_zone

    @property
    def days_until_meeting(self):
        """Gets the days_until_meeting of this CreateOutlookEventTaskParams.  # noqa: E501

        The days until meeting  # noqa: E501

        :return: The days_until_meeting of this CreateOutlookEventTaskParams.  # noqa: E501
        :rtype: int
        """
        return self._days_until_meeting

    @days_until_meeting.setter
    def days_until_meeting(self, days_until_meeting):
        """Sets the days_until_meeting of this CreateOutlookEventTaskParams.

        The days until meeting  # noqa: E501

        :param days_until_meeting: The days_until_meeting of this CreateOutlookEventTaskParams.  # noqa: E501
        :type: int
        """
        if days_until_meeting is None:
            raise ValueError("Invalid value for `days_until_meeting`, must not be `None`")  # noqa: E501

        self._days_until_meeting = days_until_meeting

    @property
    def time_of_meeting(self):
        """Gets the time_of_meeting of this CreateOutlookEventTaskParams.  # noqa: E501

        Time of meeting in format HH:MM  # noqa: E501

        :return: The time_of_meeting of this CreateOutlookEventTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._time_of_meeting

    @time_of_meeting.setter
    def time_of_meeting(self, time_of_meeting):
        """Sets the time_of_meeting of this CreateOutlookEventTaskParams.

        Time of meeting in format HH:MM  # noqa: E501

        :param time_of_meeting: The time_of_meeting of this CreateOutlookEventTaskParams.  # noqa: E501
        :type: str
        """
        if time_of_meeting is None:
            raise ValueError("Invalid value for `time_of_meeting`, must not be `None`")  # noqa: E501

        self._time_of_meeting = time_of_meeting

    @property
    def meeting_duration(self):
        """Gets the meeting_duration of this CreateOutlookEventTaskParams.  # noqa: E501

        Meeting duration in format like '1 hour', '30 minutes'  # noqa: E501

        :return: The meeting_duration of this CreateOutlookEventTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._meeting_duration

    @meeting_duration.setter
    def meeting_duration(self, meeting_duration):
        """Sets the meeting_duration of this CreateOutlookEventTaskParams.

        Meeting duration in format like '1 hour', '30 minutes'  # noqa: E501

        :param meeting_duration: The meeting_duration of this CreateOutlookEventTaskParams.  # noqa: E501
        :type: str
        """
        if meeting_duration is None:
            raise ValueError("Invalid value for `meeting_duration`, must not be `None`")  # noqa: E501

        self._meeting_duration = meeting_duration

    @property
    def summary(self):
        """Gets the summary of this CreateOutlookEventTaskParams.  # noqa: E501

        The event summary  # noqa: E501

        :return: The summary of this CreateOutlookEventTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._summary

    @summary.setter
    def summary(self, summary):
        """Sets the summary of this CreateOutlookEventTaskParams.

        The event summary  # noqa: E501

        :param summary: The summary of this CreateOutlookEventTaskParams.  # noqa: E501
        :type: str
        """
        if summary is None:
            raise ValueError("Invalid value for `summary`, must not be `None`")  # noqa: E501

        self._summary = summary

    @property
    def description(self):
        """Gets the description of this CreateOutlookEventTaskParams.  # noqa: E501

        The event description  # noqa: E501

        :return: The description of this CreateOutlookEventTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CreateOutlookEventTaskParams.

        The event description  # noqa: E501

        :param description: The description of this CreateOutlookEventTaskParams.  # noqa: E501
        :type: str
        """
        if description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    @property
    def exclude_weekends(self):
        """Gets the exclude_weekends of this CreateOutlookEventTaskParams.  # noqa: E501


        :return: The exclude_weekends of this CreateOutlookEventTaskParams.  # noqa: E501
        :rtype: bool
        """
        return self._exclude_weekends

    @exclude_weekends.setter
    def exclude_weekends(self, exclude_weekends):
        """Sets the exclude_weekends of this CreateOutlookEventTaskParams.


        :param exclude_weekends: The exclude_weekends of this CreateOutlookEventTaskParams.  # noqa: E501
        :type: bool
        """

        self._exclude_weekends = exclude_weekends

    @property
    def post_to_incident_timeline(self):
        """Gets the post_to_incident_timeline of this CreateOutlookEventTaskParams.  # noqa: E501


        :return: The post_to_incident_timeline of this CreateOutlookEventTaskParams.  # noqa: E501
        :rtype: bool
        """
        return self._post_to_incident_timeline

    @post_to_incident_timeline.setter
    def post_to_incident_timeline(self, post_to_incident_timeline):
        """Sets the post_to_incident_timeline of this CreateOutlookEventTaskParams.


        :param post_to_incident_timeline: The post_to_incident_timeline of this CreateOutlookEventTaskParams.  # noqa: E501
        :type: bool
        """

        self._post_to_incident_timeline = post_to_incident_timeline

    @property
    def post_to_slack_channels(self):
        """Gets the post_to_slack_channels of this CreateOutlookEventTaskParams.  # noqa: E501


        :return: The post_to_slack_channels of this CreateOutlookEventTaskParams.  # noqa: E501
        :rtype: list[AddActionItemTaskParamsPostToSlackChannels]
        """
        return self._post_to_slack_channels

    @post_to_slack_channels.setter
    def post_to_slack_channels(self, post_to_slack_channels):
        """Sets the post_to_slack_channels of this CreateOutlookEventTaskParams.


        :param post_to_slack_channels: The post_to_slack_channels of this CreateOutlookEventTaskParams.  # noqa: E501
        :type: list[AddActionItemTaskParamsPostToSlackChannels]
        """

        self._post_to_slack_channels = post_to_slack_channels

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateOutlookEventTaskParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateOutlookEventTaskParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
