# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateZendeskTicketTaskParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'task_type': 'str',
        'kind': 'str',
        'subject': 'str',
        'comment': 'str',
        'tags': 'str',
        'priority': 'CreateJiraIssueTaskParamsPriority',
        'completion': 'CreateServiceNowIncidentTaskParamsCompletion',
        'custom_fields_mapping': 'str',
        'ticket_payload': 'str'
    }

    attribute_map = {
        'task_type': 'task_type',
        'kind': 'kind',
        'subject': 'subject',
        'comment': 'comment',
        'tags': 'tags',
        'priority': 'priority',
        'completion': 'completion',
        'custom_fields_mapping': 'custom_fields_mapping',
        'ticket_payload': 'ticket_payload'
    }

    def __init__(self, task_type=None, kind=None, subject=None, comment=None, tags=None, priority=None, completion=None, custom_fields_mapping=None, ticket_payload=None):  # noqa: E501
        """CreateZendeskTicketTaskParams - a model defined in Swagger"""  # noqa: E501
        self._task_type = None
        self._kind = None
        self._subject = None
        self._comment = None
        self._tags = None
        self._priority = None
        self._completion = None
        self._custom_fields_mapping = None
        self._ticket_payload = None
        self.discriminator = None
        if task_type is not None:
            self.task_type = task_type
        self.kind = kind
        self.subject = subject
        if comment is not None:
            self.comment = comment
        if tags is not None:
            self.tags = tags
        if priority is not None:
            self.priority = priority
        if completion is not None:
            self.completion = completion
        if custom_fields_mapping is not None:
            self.custom_fields_mapping = custom_fields_mapping
        if ticket_payload is not None:
            self.ticket_payload = ticket_payload

    @property
    def task_type(self):
        """Gets the task_type of this CreateZendeskTicketTaskParams.  # noqa: E501


        :return: The task_type of this CreateZendeskTicketTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._task_type

    @task_type.setter
    def task_type(self, task_type):
        """Sets the task_type of this CreateZendeskTicketTaskParams.


        :param task_type: The task_type of this CreateZendeskTicketTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["create_zendesk_ticket"]  # noqa: E501
        if task_type not in allowed_values:
            raise ValueError(
                "Invalid value for `task_type` ({0}), must be one of {1}"  # noqa: E501
                .format(task_type, allowed_values)
            )

        self._task_type = task_type

    @property
    def kind(self):
        """Gets the kind of this CreateZendeskTicketTaskParams.  # noqa: E501


        :return: The kind of this CreateZendeskTicketTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._kind

    @kind.setter
    def kind(self, kind):
        """Sets the kind of this CreateZendeskTicketTaskParams.


        :param kind: The kind of this CreateZendeskTicketTaskParams.  # noqa: E501
        :type: str
        """
        if kind is None:
            raise ValueError("Invalid value for `kind`, must not be `None`")  # noqa: E501
        allowed_values = ["problem", "incident", "question", "task"]  # noqa: E501
        if kind not in allowed_values:
            raise ValueError(
                "Invalid value for `kind` ({0}), must be one of {1}"  # noqa: E501
                .format(kind, allowed_values)
            )

        self._kind = kind

    @property
    def subject(self):
        """Gets the subject of this CreateZendeskTicketTaskParams.  # noqa: E501

        The ticket subject  # noqa: E501

        :return: The subject of this CreateZendeskTicketTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._subject

    @subject.setter
    def subject(self, subject):
        """Sets the subject of this CreateZendeskTicketTaskParams.

        The ticket subject  # noqa: E501

        :param subject: The subject of this CreateZendeskTicketTaskParams.  # noqa: E501
        :type: str
        """
        if subject is None:
            raise ValueError("Invalid value for `subject`, must not be `None`")  # noqa: E501

        self._subject = subject

    @property
    def comment(self):
        """Gets the comment of this CreateZendeskTicketTaskParams.  # noqa: E501

        The ticket comment  # noqa: E501

        :return: The comment of this CreateZendeskTicketTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this CreateZendeskTicketTaskParams.

        The ticket comment  # noqa: E501

        :param comment: The comment of this CreateZendeskTicketTaskParams.  # noqa: E501
        :type: str
        """

        self._comment = comment

    @property
    def tags(self):
        """Gets the tags of this CreateZendeskTicketTaskParams.  # noqa: E501

        The ticket tags  # noqa: E501

        :return: The tags of this CreateZendeskTicketTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this CreateZendeskTicketTaskParams.

        The ticket tags  # noqa: E501

        :param tags: The tags of this CreateZendeskTicketTaskParams.  # noqa: E501
        :type: str
        """

        self._tags = tags

    @property
    def priority(self):
        """Gets the priority of this CreateZendeskTicketTaskParams.  # noqa: E501


        :return: The priority of this CreateZendeskTicketTaskParams.  # noqa: E501
        :rtype: CreateJiraIssueTaskParamsPriority
        """
        return self._priority

    @priority.setter
    def priority(self, priority):
        """Sets the priority of this CreateZendeskTicketTaskParams.


        :param priority: The priority of this CreateZendeskTicketTaskParams.  # noqa: E501
        :type: CreateJiraIssueTaskParamsPriority
        """

        self._priority = priority

    @property
    def completion(self):
        """Gets the completion of this CreateZendeskTicketTaskParams.  # noqa: E501


        :return: The completion of this CreateZendeskTicketTaskParams.  # noqa: E501
        :rtype: CreateServiceNowIncidentTaskParamsCompletion
        """
        return self._completion

    @completion.setter
    def completion(self, completion):
        """Sets the completion of this CreateZendeskTicketTaskParams.


        :param completion: The completion of this CreateZendeskTicketTaskParams.  # noqa: E501
        :type: CreateServiceNowIncidentTaskParamsCompletion
        """

        self._completion = completion

    @property
    def custom_fields_mapping(self):
        """Gets the custom_fields_mapping of this CreateZendeskTicketTaskParams.  # noqa: E501

        Custom field mappings. Can contain liquid markup and need to be valid JSON  # noqa: E501

        :return: The custom_fields_mapping of this CreateZendeskTicketTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._custom_fields_mapping

    @custom_fields_mapping.setter
    def custom_fields_mapping(self, custom_fields_mapping):
        """Sets the custom_fields_mapping of this CreateZendeskTicketTaskParams.

        Custom field mappings. Can contain liquid markup and need to be valid JSON  # noqa: E501

        :param custom_fields_mapping: The custom_fields_mapping of this CreateZendeskTicketTaskParams.  # noqa: E501
        :type: str
        """

        self._custom_fields_mapping = custom_fields_mapping

    @property
    def ticket_payload(self):
        """Gets the ticket_payload of this CreateZendeskTicketTaskParams.  # noqa: E501

        Additional Zendesk ticket attributes. Will be merged into whatever was specified in this tasks current parameters. Can contain liquid markup and need to be valid JSON  # noqa: E501

        :return: The ticket_payload of this CreateZendeskTicketTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._ticket_payload

    @ticket_payload.setter
    def ticket_payload(self, ticket_payload):
        """Sets the ticket_payload of this CreateZendeskTicketTaskParams.

        Additional Zendesk ticket attributes. Will be merged into whatever was specified in this tasks current parameters. Can contain liquid markup and need to be valid JSON  # noqa: E501

        :param ticket_payload: The ticket_payload of this CreateZendeskTicketTaskParams.  # noqa: E501
        :type: str
        """

        self._ticket_payload = ticket_payload

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateZendeskTicketTaskParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateZendeskTicketTaskParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
