# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DuplicateIncidentDataAttributes(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'duplicate_incident_id': 'str',
        'auto_cancel_incident': 'bool',
        'reason_for_cancellation': 'str'
    }

    attribute_map = {
        'duplicate_incident_id': 'duplicate_incident_id',
        'auto_cancel_incident': 'auto_cancel_incident',
        'reason_for_cancellation': 'reason_for_cancellation'
    }

    def __init__(self, duplicate_incident_id=None, auto_cancel_incident=True, reason_for_cancellation=None):  # noqa: E501
        """DuplicateIncidentDataAttributes - a model defined in Swagger"""  # noqa: E501
        self._duplicate_incident_id = None
        self._auto_cancel_incident = None
        self._reason_for_cancellation = None
        self.discriminator = None
        if duplicate_incident_id is not None:
            self.duplicate_incident_id = duplicate_incident_id
        if auto_cancel_incident is not None:
            self.auto_cancel_incident = auto_cancel_incident
        if reason_for_cancellation is not None:
            self.reason_for_cancellation = reason_for_cancellation

    @property
    def duplicate_incident_id(self):
        """Gets the duplicate_incident_id of this DuplicateIncidentDataAttributes.  # noqa: E501


        :return: The duplicate_incident_id of this DuplicateIncidentDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._duplicate_incident_id

    @duplicate_incident_id.setter
    def duplicate_incident_id(self, duplicate_incident_id):
        """Sets the duplicate_incident_id of this DuplicateIncidentDataAttributes.


        :param duplicate_incident_id: The duplicate_incident_id of this DuplicateIncidentDataAttributes.  # noqa: E501
        :type: str
        """

        self._duplicate_incident_id = duplicate_incident_id

    @property
    def auto_cancel_incident(self):
        """Gets the auto_cancel_incident of this DuplicateIncidentDataAttributes.  # noqa: E501


        :return: The auto_cancel_incident of this DuplicateIncidentDataAttributes.  # noqa: E501
        :rtype: bool
        """
        return self._auto_cancel_incident

    @auto_cancel_incident.setter
    def auto_cancel_incident(self, auto_cancel_incident):
        """Sets the auto_cancel_incident of this DuplicateIncidentDataAttributes.


        :param auto_cancel_incident: The auto_cancel_incident of this DuplicateIncidentDataAttributes.  # noqa: E501
        :type: bool
        """

        self._auto_cancel_incident = auto_cancel_incident

    @property
    def reason_for_cancellation(self):
        """Gets the reason_for_cancellation of this DuplicateIncidentDataAttributes.  # noqa: E501

        Why was the incident cancelled?  # noqa: E501

        :return: The reason_for_cancellation of this DuplicateIncidentDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._reason_for_cancellation

    @reason_for_cancellation.setter
    def reason_for_cancellation(self, reason_for_cancellation):
        """Sets the reason_for_cancellation of this DuplicateIncidentDataAttributes.

        Why was the incident cancelled?  # noqa: E501

        :param reason_for_cancellation: The reason_for_cancellation of this DuplicateIncidentDataAttributes.  # noqa: E501
        :type: str
        """

        self._reason_for_cancellation = reason_for_cancellation

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DuplicateIncidentDataAttributes, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DuplicateIncidentDataAttributes):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
