# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class EscalationPolicy(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'repeat_count': 'int',
        'created_by_user_id': 'int',
        'last_updated_by_user_id': 'int',
        'group_ids': 'list[str]',
        'service_ids': 'list[str]',
        'created_at': 'str',
        'updated_at': 'str'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'repeat_count': 'repeat_count',
        'created_by_user_id': 'created_by_user_id',
        'last_updated_by_user_id': 'last_updated_by_user_id',
        'group_ids': 'group_ids',
        'service_ids': 'service_ids',
        'created_at': 'created_at',
        'updated_at': 'updated_at'
    }

    def __init__(self, name=None, description=None, repeat_count=None, created_by_user_id=None, last_updated_by_user_id=None, group_ids=None, service_ids=None, created_at=None, updated_at=None):  # noqa: E501
        """EscalationPolicy - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._repeat_count = None
        self._created_by_user_id = None
        self._last_updated_by_user_id = None
        self._group_ids = None
        self._service_ids = None
        self._created_at = None
        self._updated_at = None
        self.discriminator = None
        self.name = name
        if description is not None:
            self.description = description
        self.repeat_count = repeat_count
        self.created_by_user_id = created_by_user_id
        if last_updated_by_user_id is not None:
            self.last_updated_by_user_id = last_updated_by_user_id
        if group_ids is not None:
            self.group_ids = group_ids
        if service_ids is not None:
            self.service_ids = service_ids
        if created_at is not None:
            self.created_at = created_at
        if updated_at is not None:
            self.updated_at = updated_at

    @property
    def name(self):
        """Gets the name of this EscalationPolicy.  # noqa: E501

        The name of the escalation policy  # noqa: E501

        :return: The name of this EscalationPolicy.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this EscalationPolicy.

        The name of the escalation policy  # noqa: E501

        :param name: The name of this EscalationPolicy.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this EscalationPolicy.  # noqa: E501

        The description of the escalation policy  # noqa: E501

        :return: The description of this EscalationPolicy.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this EscalationPolicy.

        The description of the escalation policy  # noqa: E501

        :param description: The description of this EscalationPolicy.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def repeat_count(self):
        """Gets the repeat_count of this EscalationPolicy.  # noqa: E501

        The number of times this policy will be executed until someone acknowledges the alert  # noqa: E501

        :return: The repeat_count of this EscalationPolicy.  # noqa: E501
        :rtype: int
        """
        return self._repeat_count

    @repeat_count.setter
    def repeat_count(self, repeat_count):
        """Sets the repeat_count of this EscalationPolicy.

        The number of times this policy will be executed until someone acknowledges the alert  # noqa: E501

        :param repeat_count: The repeat_count of this EscalationPolicy.  # noqa: E501
        :type: int
        """
        if repeat_count is None:
            raise ValueError("Invalid value for `repeat_count`, must not be `None`")  # noqa: E501

        self._repeat_count = repeat_count

    @property
    def created_by_user_id(self):
        """Gets the created_by_user_id of this EscalationPolicy.  # noqa: E501

        User who created the escalation policy  # noqa: E501

        :return: The created_by_user_id of this EscalationPolicy.  # noqa: E501
        :rtype: int
        """
        return self._created_by_user_id

    @created_by_user_id.setter
    def created_by_user_id(self, created_by_user_id):
        """Sets the created_by_user_id of this EscalationPolicy.

        User who created the escalation policy  # noqa: E501

        :param created_by_user_id: The created_by_user_id of this EscalationPolicy.  # noqa: E501
        :type: int
        """
        if created_by_user_id is None:
            raise ValueError("Invalid value for `created_by_user_id`, must not be `None`")  # noqa: E501

        self._created_by_user_id = created_by_user_id

    @property
    def last_updated_by_user_id(self):
        """Gets the last_updated_by_user_id of this EscalationPolicy.  # noqa: E501

        User who updated the escalation policy  # noqa: E501

        :return: The last_updated_by_user_id of this EscalationPolicy.  # noqa: E501
        :rtype: int
        """
        return self._last_updated_by_user_id

    @last_updated_by_user_id.setter
    def last_updated_by_user_id(self, last_updated_by_user_id):
        """Sets the last_updated_by_user_id of this EscalationPolicy.

        User who updated the escalation policy  # noqa: E501

        :param last_updated_by_user_id: The last_updated_by_user_id of this EscalationPolicy.  # noqa: E501
        :type: int
        """

        self._last_updated_by_user_id = last_updated_by_user_id

    @property
    def group_ids(self):
        """Gets the group_ids of this EscalationPolicy.  # noqa: E501

        Associated groups (alerting the group will trigger escalation policy)  # noqa: E501

        :return: The group_ids of this EscalationPolicy.  # noqa: E501
        :rtype: list[str]
        """
        return self._group_ids

    @group_ids.setter
    def group_ids(self, group_ids):
        """Sets the group_ids of this EscalationPolicy.

        Associated groups (alerting the group will trigger escalation policy)  # noqa: E501

        :param group_ids: The group_ids of this EscalationPolicy.  # noqa: E501
        :type: list[str]
        """

        self._group_ids = group_ids

    @property
    def service_ids(self):
        """Gets the service_ids of this EscalationPolicy.  # noqa: E501

        Associated services (alerting the service will trigger escalation policy)  # noqa: E501

        :return: The service_ids of this EscalationPolicy.  # noqa: E501
        :rtype: list[str]
        """
        return self._service_ids

    @service_ids.setter
    def service_ids(self, service_ids):
        """Sets the service_ids of this EscalationPolicy.

        Associated services (alerting the service will trigger escalation policy)  # noqa: E501

        :param service_ids: The service_ids of this EscalationPolicy.  # noqa: E501
        :type: list[str]
        """

        self._service_ids = service_ids

    @property
    def created_at(self):
        """Gets the created_at of this EscalationPolicy.  # noqa: E501

        Date of creation  # noqa: E501

        :return: The created_at of this EscalationPolicy.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this EscalationPolicy.

        Date of creation  # noqa: E501

        :param created_at: The created_at of this EscalationPolicy.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this EscalationPolicy.  # noqa: E501

        Date of last update  # noqa: E501

        :return: The updated_at of this EscalationPolicy.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this EscalationPolicy.

        Date of last update  # noqa: E501

        :param updated_at: The updated_at of this EscalationPolicy.  # noqa: E501
        :type: str
        """

        self._updated_at = updated_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EscalationPolicy, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EscalationPolicy):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
