# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class FormFieldPosition(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'form_field_id': 'str',
        'form': 'str',
        'position': 'int'
    }

    attribute_map = {
        'form_field_id': 'form_field_id',
        'form': 'form',
        'position': 'position'
    }

    def __init__(self, form_field_id=None, form=None, position=None):  # noqa: E501
        """FormFieldPosition - a model defined in Swagger"""  # noqa: E501
        self._form_field_id = None
        self._form = None
        self._position = None
        self.discriminator = None
        self.form_field_id = form_field_id
        self.form = form
        self.position = position

    @property
    def form_field_id(self):
        """Gets the form_field_id of this FormFieldPosition.  # noqa: E501

        The ID of the form field.  # noqa: E501

        :return: The form_field_id of this FormFieldPosition.  # noqa: E501
        :rtype: str
        """
        return self._form_field_id

    @form_field_id.setter
    def form_field_id(self, form_field_id):
        """Sets the form_field_id of this FormFieldPosition.

        The ID of the form field.  # noqa: E501

        :param form_field_id: The form_field_id of this FormFieldPosition.  # noqa: E501
        :type: str
        """
        if form_field_id is None:
            raise ValueError("Invalid value for `form_field_id`, must not be `None`")  # noqa: E501

        self._form_field_id = form_field_id

    @property
    def form(self):
        """Gets the form of this FormFieldPosition.  # noqa: E501

        The form for the position  # noqa: E501

        :return: The form of this FormFieldPosition.  # noqa: E501
        :rtype: str
        """
        return self._form

    @form.setter
    def form(self, form):
        """Sets the form of this FormFieldPosition.

        The form for the position  # noqa: E501

        :param form: The form of this FormFieldPosition.  # noqa: E501
        :type: str
        """
        if form is None:
            raise ValueError("Invalid value for `form`, must not be `None`")  # noqa: E501
        allowed_values = ["web_new_incident_form", "web_update_incident_form", "web_incident_post_mortem_form", "web_incident_mitigation_form", "web_incident_resolution_form", "web_incident_cancellation_form", "web_scheduled_incident_form", "web_update_scheduled_incident_form", "incident_post_mortem", "slack_new_incident_form", "slack_update_incident_form", "slack_update_incident_status_form", "slack_incident_mitigation_form", "slack_incident_resolution_form", "slack_incident_cancellation_form", "slack_scheduled_incident_form", "slack_update_scheduled_incident_form"]  # noqa: E501
        if form not in allowed_values:
            raise ValueError(
                "Invalid value for `form` ({0}), must be one of {1}"  # noqa: E501
                .format(form, allowed_values)
            )

        self._form = form

    @property
    def position(self):
        """Gets the position of this FormFieldPosition.  # noqa: E501

        The position of the form_field_position  # noqa: E501

        :return: The position of this FormFieldPosition.  # noqa: E501
        :rtype: int
        """
        return self._position

    @position.setter
    def position(self, position):
        """Sets the position of this FormFieldPosition.

        The position of the form_field_position  # noqa: E501

        :param position: The position of this FormFieldPosition.  # noqa: E501
        :type: int
        """
        if position is None:
            raise ValueError("Invalid value for `position`, must not be `None`")  # noqa: E501

        self._position = position

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FormFieldPosition, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FormFieldPosition):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
