# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class HttpClientTaskParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'task_type': 'str',
        'headers': 'str',
        'params': 'str',
        'body': 'str',
        'url': 'str',
        'event_url': 'str',
        'event_message': 'str',
        'method': 'str',
        'succeed_on_status': 'str',
        'post_to_incident_timeline': 'bool',
        'post_to_slack_channels': 'list[AddActionItemTaskParamsPostToSlackChannels]'
    }

    attribute_map = {
        'task_type': 'task_type',
        'headers': 'headers',
        'params': 'params',
        'body': 'body',
        'url': 'url',
        'event_url': 'event_url',
        'event_message': 'event_message',
        'method': 'method',
        'succeed_on_status': 'succeed_on_status',
        'post_to_incident_timeline': 'post_to_incident_timeline',
        'post_to_slack_channels': 'post_to_slack_channels'
    }

    def __init__(self, task_type=None, headers=None, params=None, body=None, url=None, event_url=None, event_message=None, method='GET', succeed_on_status=None, post_to_incident_timeline=None, post_to_slack_channels=None):  # noqa: E501
        """HttpClientTaskParams - a model defined in Swagger"""  # noqa: E501
        self._task_type = None
        self._headers = None
        self._params = None
        self._body = None
        self._url = None
        self._event_url = None
        self._event_message = None
        self._method = None
        self._succeed_on_status = None
        self._post_to_incident_timeline = None
        self._post_to_slack_channels = None
        self.discriminator = None
        if task_type is not None:
            self.task_type = task_type
        if headers is not None:
            self.headers = headers
        if params is not None:
            self.params = params
        if body is not None:
            self.body = body
        self.url = url
        if event_url is not None:
            self.event_url = event_url
        if event_message is not None:
            self.event_message = event_message
        if method is not None:
            self.method = method
        self.succeed_on_status = succeed_on_status
        if post_to_incident_timeline is not None:
            self.post_to_incident_timeline = post_to_incident_timeline
        if post_to_slack_channels is not None:
            self.post_to_slack_channels = post_to_slack_channels

    @property
    def task_type(self):
        """Gets the task_type of this HttpClientTaskParams.  # noqa: E501


        :return: The task_type of this HttpClientTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._task_type

    @task_type.setter
    def task_type(self, task_type):
        """Sets the task_type of this HttpClientTaskParams.


        :param task_type: The task_type of this HttpClientTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["http_client"]  # noqa: E501
        if task_type not in allowed_values:
            raise ValueError(
                "Invalid value for `task_type` ({0}), must be one of {1}"  # noqa: E501
                .format(task_type, allowed_values)
            )

        self._task_type = task_type

    @property
    def headers(self):
        """Gets the headers of this HttpClientTaskParams.  # noqa: E501

        JSON map of HTTP headers  # noqa: E501

        :return: The headers of this HttpClientTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._headers

    @headers.setter
    def headers(self, headers):
        """Sets the headers of this HttpClientTaskParams.

        JSON map of HTTP headers  # noqa: E501

        :param headers: The headers of this HttpClientTaskParams.  # noqa: E501
        :type: str
        """

        self._headers = headers

    @property
    def params(self):
        """Gets the params of this HttpClientTaskParams.  # noqa: E501

        JSON map of HTTP query parameters  # noqa: E501

        :return: The params of this HttpClientTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._params

    @params.setter
    def params(self, params):
        """Sets the params of this HttpClientTaskParams.

        JSON map of HTTP query parameters  # noqa: E501

        :param params: The params of this HttpClientTaskParams.  # noqa: E501
        :type: str
        """

        self._params = params

    @property
    def body(self):
        """Gets the body of this HttpClientTaskParams.  # noqa: E501

        HTTP body  # noqa: E501

        :return: The body of this HttpClientTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._body

    @body.setter
    def body(self, body):
        """Sets the body of this HttpClientTaskParams.

        HTTP body  # noqa: E501

        :param body: The body of this HttpClientTaskParams.  # noqa: E501
        :type: str
        """

        self._body = body

    @property
    def url(self):
        """Gets the url of this HttpClientTaskParams.  # noqa: E501

        URL endpoint  # noqa: E501

        :return: The url of this HttpClientTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this HttpClientTaskParams.

        URL endpoint  # noqa: E501

        :param url: The url of this HttpClientTaskParams.  # noqa: E501
        :type: str
        """
        if url is None:
            raise ValueError("Invalid value for `url`, must not be `None`")  # noqa: E501

        self._url = url

    @property
    def event_url(self):
        """Gets the event_url of this HttpClientTaskParams.  # noqa: E501


        :return: The event_url of this HttpClientTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._event_url

    @event_url.setter
    def event_url(self, event_url):
        """Sets the event_url of this HttpClientTaskParams.


        :param event_url: The event_url of this HttpClientTaskParams.  # noqa: E501
        :type: str
        """

        self._event_url = event_url

    @property
    def event_message(self):
        """Gets the event_message of this HttpClientTaskParams.  # noqa: E501


        :return: The event_message of this HttpClientTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._event_message

    @event_message.setter
    def event_message(self, event_message):
        """Sets the event_message of this HttpClientTaskParams.


        :param event_message: The event_message of this HttpClientTaskParams.  # noqa: E501
        :type: str
        """

        self._event_message = event_message

    @property
    def method(self):
        """Gets the method of this HttpClientTaskParams.  # noqa: E501

        HTTP method  # noqa: E501

        :return: The method of this HttpClientTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._method

    @method.setter
    def method(self, method):
        """Sets the method of this HttpClientTaskParams.

        HTTP method  # noqa: E501

        :param method: The method of this HttpClientTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["GET", "POST", "PATCH", "PUT", "DELETE", "OPTIONS"]  # noqa: E501
        if method not in allowed_values:
            raise ValueError(
                "Invalid value for `method` ({0}), must be one of {1}"  # noqa: E501
                .format(method, allowed_values)
            )

        self._method = method

    @property
    def succeed_on_status(self):
        """Gets the succeed_on_status of this HttpClientTaskParams.  # noqa: E501

        HTTP status code expected. Can be a regular expression. Eg: 200, 200|203, 20[0-3]  # noqa: E501

        :return: The succeed_on_status of this HttpClientTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._succeed_on_status

    @succeed_on_status.setter
    def succeed_on_status(self, succeed_on_status):
        """Sets the succeed_on_status of this HttpClientTaskParams.

        HTTP status code expected. Can be a regular expression. Eg: 200, 200|203, 20[0-3]  # noqa: E501

        :param succeed_on_status: The succeed_on_status of this HttpClientTaskParams.  # noqa: E501
        :type: str
        """
        if succeed_on_status is None:
            raise ValueError("Invalid value for `succeed_on_status`, must not be `None`")  # noqa: E501

        self._succeed_on_status = succeed_on_status

    @property
    def post_to_incident_timeline(self):
        """Gets the post_to_incident_timeline of this HttpClientTaskParams.  # noqa: E501


        :return: The post_to_incident_timeline of this HttpClientTaskParams.  # noqa: E501
        :rtype: bool
        """
        return self._post_to_incident_timeline

    @post_to_incident_timeline.setter
    def post_to_incident_timeline(self, post_to_incident_timeline):
        """Sets the post_to_incident_timeline of this HttpClientTaskParams.


        :param post_to_incident_timeline: The post_to_incident_timeline of this HttpClientTaskParams.  # noqa: E501
        :type: bool
        """

        self._post_to_incident_timeline = post_to_incident_timeline

    @property
    def post_to_slack_channels(self):
        """Gets the post_to_slack_channels of this HttpClientTaskParams.  # noqa: E501


        :return: The post_to_slack_channels of this HttpClientTaskParams.  # noqa: E501
        :rtype: list[AddActionItemTaskParamsPostToSlackChannels]
        """
        return self._post_to_slack_channels

    @post_to_slack_channels.setter
    def post_to_slack_channels(self, post_to_slack_channels):
        """Sets the post_to_slack_channels of this HttpClientTaskParams.


        :param post_to_slack_channels: The post_to_slack_channels of this HttpClientTaskParams.  # noqa: E501
        :type: list[AddActionItemTaskParamsPostToSlackChannels]
        """

        self._post_to_slack_channels = post_to_slack_channels

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(HttpClientTaskParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HttpClientTaskParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
