# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class IncidentActionItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'summary': 'str',
        'description': 'str',
        'kind': 'str',
        'assigned_to_user_id': 'int',
        'assigned_to_group_ids': 'list[str]',
        'priority': 'str',
        'status': 'str',
        'due_date': 'str',
        'jira_issue_id': 'str',
        'jira_issue_url': 'str',
        'created_at': 'str',
        'updated_at': 'str'
    }

    attribute_map = {
        'summary': 'summary',
        'description': 'description',
        'kind': 'kind',
        'assigned_to_user_id': 'assigned_to_user_id',
        'assigned_to_group_ids': 'assigned_to_group_ids',
        'priority': 'priority',
        'status': 'status',
        'due_date': 'due_date',
        'jira_issue_id': 'jira_issue_id',
        'jira_issue_url': 'jira_issue_url',
        'created_at': 'created_at',
        'updated_at': 'updated_at'
    }

    def __init__(self, summary=None, description=None, kind=None, assigned_to_user_id=None, assigned_to_group_ids=None, priority=None, status=None, due_date=None, jira_issue_id=None, jira_issue_url=None, created_at=None, updated_at=None):  # noqa: E501
        """IncidentActionItem - a model defined in Swagger"""  # noqa: E501
        self._summary = None
        self._description = None
        self._kind = None
        self._assigned_to_user_id = None
        self._assigned_to_group_ids = None
        self._priority = None
        self._status = None
        self._due_date = None
        self._jira_issue_id = None
        self._jira_issue_url = None
        self._created_at = None
        self._updated_at = None
        self.discriminator = None
        self.summary = summary
        if description is not None:
            self.description = description
        if kind is not None:
            self.kind = kind
        if assigned_to_user_id is not None:
            self.assigned_to_user_id = assigned_to_user_id
        if assigned_to_group_ids is not None:
            self.assigned_to_group_ids = assigned_to_group_ids
        if priority is not None:
            self.priority = priority
        if status is not None:
            self.status = status
        if due_date is not None:
            self.due_date = due_date
        if jira_issue_id is not None:
            self.jira_issue_id = jira_issue_id
        if jira_issue_url is not None:
            self.jira_issue_url = jira_issue_url
        self.created_at = created_at
        self.updated_at = updated_at

    @property
    def summary(self):
        """Gets the summary of this IncidentActionItem.  # noqa: E501

        The summary of the action item  # noqa: E501

        :return: The summary of this IncidentActionItem.  # noqa: E501
        :rtype: str
        """
        return self._summary

    @summary.setter
    def summary(self, summary):
        """Sets the summary of this IncidentActionItem.

        The summary of the action item  # noqa: E501

        :param summary: The summary of this IncidentActionItem.  # noqa: E501
        :type: str
        """
        if summary is None:
            raise ValueError("Invalid value for `summary`, must not be `None`")  # noqa: E501

        self._summary = summary

    @property
    def description(self):
        """Gets the description of this IncidentActionItem.  # noqa: E501

        The description of incident action item  # noqa: E501

        :return: The description of this IncidentActionItem.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this IncidentActionItem.

        The description of incident action item  # noqa: E501

        :param description: The description of this IncidentActionItem.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def kind(self):
        """Gets the kind of this IncidentActionItem.  # noqa: E501

        The kind of the action item  # noqa: E501

        :return: The kind of this IncidentActionItem.  # noqa: E501
        :rtype: str
        """
        return self._kind

    @kind.setter
    def kind(self, kind):
        """Sets the kind of this IncidentActionItem.

        The kind of the action item  # noqa: E501

        :param kind: The kind of this IncidentActionItem.  # noqa: E501
        :type: str
        """
        allowed_values = ["task", "follow_up"]  # noqa: E501
        if kind not in allowed_values:
            raise ValueError(
                "Invalid value for `kind` ({0}), must be one of {1}"  # noqa: E501
                .format(kind, allowed_values)
            )

        self._kind = kind

    @property
    def assigned_to_user_id(self):
        """Gets the assigned_to_user_id of this IncidentActionItem.  # noqa: E501

        ID of user you wish to assign this action item  # noqa: E501

        :return: The assigned_to_user_id of this IncidentActionItem.  # noqa: E501
        :rtype: int
        """
        return self._assigned_to_user_id

    @assigned_to_user_id.setter
    def assigned_to_user_id(self, assigned_to_user_id):
        """Sets the assigned_to_user_id of this IncidentActionItem.

        ID of user you wish to assign this action item  # noqa: E501

        :param assigned_to_user_id: The assigned_to_user_id of this IncidentActionItem.  # noqa: E501
        :type: int
        """

        self._assigned_to_user_id = assigned_to_user_id

    @property
    def assigned_to_group_ids(self):
        """Gets the assigned_to_group_ids of this IncidentActionItem.  # noqa: E501

        IDs of groups you wish to assign this action item  # noqa: E501

        :return: The assigned_to_group_ids of this IncidentActionItem.  # noqa: E501
        :rtype: list[str]
        """
        return self._assigned_to_group_ids

    @assigned_to_group_ids.setter
    def assigned_to_group_ids(self, assigned_to_group_ids):
        """Sets the assigned_to_group_ids of this IncidentActionItem.

        IDs of groups you wish to assign this action item  # noqa: E501

        :param assigned_to_group_ids: The assigned_to_group_ids of this IncidentActionItem.  # noqa: E501
        :type: list[str]
        """

        self._assigned_to_group_ids = assigned_to_group_ids

    @property
    def priority(self):
        """Gets the priority of this IncidentActionItem.  # noqa: E501

        The priority of the action item  # noqa: E501

        :return: The priority of this IncidentActionItem.  # noqa: E501
        :rtype: str
        """
        return self._priority

    @priority.setter
    def priority(self, priority):
        """Sets the priority of this IncidentActionItem.

        The priority of the action item  # noqa: E501

        :param priority: The priority of this IncidentActionItem.  # noqa: E501
        :type: str
        """
        allowed_values = ["high", "medium", "low"]  # noqa: E501
        if priority not in allowed_values:
            raise ValueError(
                "Invalid value for `priority` ({0}), must be one of {1}"  # noqa: E501
                .format(priority, allowed_values)
            )

        self._priority = priority

    @property
    def status(self):
        """Gets the status of this IncidentActionItem.  # noqa: E501

        The status of the action item  # noqa: E501

        :return: The status of this IncidentActionItem.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this IncidentActionItem.

        The status of the action item  # noqa: E501

        :param status: The status of this IncidentActionItem.  # noqa: E501
        :type: str
        """
        allowed_values = ["open", "in_progress", "cancelled", "done"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def due_date(self):
        """Gets the due_date of this IncidentActionItem.  # noqa: E501

        The due date of the action item  # noqa: E501

        :return: The due_date of this IncidentActionItem.  # noqa: E501
        :rtype: str
        """
        return self._due_date

    @due_date.setter
    def due_date(self, due_date):
        """Sets the due_date of this IncidentActionItem.

        The due date of the action item  # noqa: E501

        :param due_date: The due_date of this IncidentActionItem.  # noqa: E501
        :type: str
        """

        self._due_date = due_date

    @property
    def jira_issue_id(self):
        """Gets the jira_issue_id of this IncidentActionItem.  # noqa: E501

        The Jira issue ID.  # noqa: E501

        :return: The jira_issue_id of this IncidentActionItem.  # noqa: E501
        :rtype: str
        """
        return self._jira_issue_id

    @jira_issue_id.setter
    def jira_issue_id(self, jira_issue_id):
        """Sets the jira_issue_id of this IncidentActionItem.

        The Jira issue ID.  # noqa: E501

        :param jira_issue_id: The jira_issue_id of this IncidentActionItem.  # noqa: E501
        :type: str
        """

        self._jira_issue_id = jira_issue_id

    @property
    def jira_issue_url(self):
        """Gets the jira_issue_url of this IncidentActionItem.  # noqa: E501

        The Jira issue URL.  # noqa: E501

        :return: The jira_issue_url of this IncidentActionItem.  # noqa: E501
        :rtype: str
        """
        return self._jira_issue_url

    @jira_issue_url.setter
    def jira_issue_url(self, jira_issue_url):
        """Sets the jira_issue_url of this IncidentActionItem.

        The Jira issue URL.  # noqa: E501

        :param jira_issue_url: The jira_issue_url of this IncidentActionItem.  # noqa: E501
        :type: str
        """

        self._jira_issue_url = jira_issue_url

    @property
    def created_at(self):
        """Gets the created_at of this IncidentActionItem.  # noqa: E501

        Date of creation  # noqa: E501

        :return: The created_at of this IncidentActionItem.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this IncidentActionItem.

        Date of creation  # noqa: E501

        :param created_at: The created_at of this IncidentActionItem.  # noqa: E501
        :type: str
        """
        if created_at is None:
            raise ValueError("Invalid value for `created_at`, must not be `None`")  # noqa: E501

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this IncidentActionItem.  # noqa: E501

        Date of last update  # noqa: E501

        :return: The updated_at of this IncidentActionItem.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this IncidentActionItem.

        Date of last update  # noqa: E501

        :param updated_at: The updated_at of this IncidentActionItem.  # noqa: E501
        :type: str
        """
        if updated_at is None:
            raise ValueError("Invalid value for `updated_at`, must not be `None`")  # noqa: E501

        self._updated_at = updated_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IncidentActionItem, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IncidentActionItem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
