# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class IncidentEventFunctionality(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'incident_event_id': 'str',
        'functionality_id': 'str',
        'status': 'str'
    }

    attribute_map = {
        'incident_event_id': 'incident_event_id',
        'functionality_id': 'functionality_id',
        'status': 'status'
    }

    def __init__(self, incident_event_id=None, functionality_id=None, status=None):  # noqa: E501
        """IncidentEventFunctionality - a model defined in Swagger"""  # noqa: E501
        self._incident_event_id = None
        self._functionality_id = None
        self._status = None
        self.discriminator = None
        self.incident_event_id = incident_event_id
        self.functionality_id = functionality_id
        self.status = status

    @property
    def incident_event_id(self):
        """Gets the incident_event_id of this IncidentEventFunctionality.  # noqa: E501

        The ID of the incident event.  # noqa: E501

        :return: The incident_event_id of this IncidentEventFunctionality.  # noqa: E501
        :rtype: str
        """
        return self._incident_event_id

    @incident_event_id.setter
    def incident_event_id(self, incident_event_id):
        """Sets the incident_event_id of this IncidentEventFunctionality.

        The ID of the incident event.  # noqa: E501

        :param incident_event_id: The incident_event_id of this IncidentEventFunctionality.  # noqa: E501
        :type: str
        """
        if incident_event_id is None:
            raise ValueError("Invalid value for `incident_event_id`, must not be `None`")  # noqa: E501

        self._incident_event_id = incident_event_id

    @property
    def functionality_id(self):
        """Gets the functionality_id of this IncidentEventFunctionality.  # noqa: E501

        The ID of the functionality.  # noqa: E501

        :return: The functionality_id of this IncidentEventFunctionality.  # noqa: E501
        :rtype: str
        """
        return self._functionality_id

    @functionality_id.setter
    def functionality_id(self, functionality_id):
        """Sets the functionality_id of this IncidentEventFunctionality.

        The ID of the functionality.  # noqa: E501

        :param functionality_id: The functionality_id of this IncidentEventFunctionality.  # noqa: E501
        :type: str
        """
        if functionality_id is None:
            raise ValueError("Invalid value for `functionality_id`, must not be `None`")  # noqa: E501

        self._functionality_id = functionality_id

    @property
    def status(self):
        """Gets the status of this IncidentEventFunctionality.  # noqa: E501

        The status of the affected functionality  # noqa: E501

        :return: The status of this IncidentEventFunctionality.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this IncidentEventFunctionality.

        The status of the affected functionality  # noqa: E501

        :param status: The status of this IncidentEventFunctionality.  # noqa: E501
        :type: str
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501
        allowed_values = ["operational", "partial_outage", "major_outage"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IncidentEventFunctionality, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IncidentEventFunctionality):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
