# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class InviteToSlackChannelRootlyTaskParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'task_type': 'str',
        'channels': 'list[AddActionItemTaskParamsPostToSlackChannels]',
        'escalation_policy_target': 'AddActionItemTaskParamsPostToSlackChannels',
        'service_target': 'AddActionItemTaskParamsPostToSlackChannels',
        'user_target': 'AddActionItemTaskParamsPostToSlackChannels',
        'group_target': 'AddActionItemTaskParamsPostToSlackChannels',
        'schedule_target': 'AddActionItemTaskParamsPostToSlackChannels'
    }

    attribute_map = {
        'task_type': 'task_type',
        'channels': 'channels',
        'escalation_policy_target': 'escalation_policy_target',
        'service_target': 'service_target',
        'user_target': 'user_target',
        'group_target': 'group_target',
        'schedule_target': 'schedule_target'
    }

    def __init__(self, task_type=None, channels=None, escalation_policy_target=None, service_target=None, user_target=None, group_target=None, schedule_target=None):  # noqa: E501
        """InviteToSlackChannelRootlyTaskParams - a model defined in Swagger"""  # noqa: E501
        self._task_type = None
        self._channels = None
        self._escalation_policy_target = None
        self._service_target = None
        self._user_target = None
        self._group_target = None
        self._schedule_target = None
        self.discriminator = None
        if task_type is not None:
            self.task_type = task_type
        if channels is not None:
            self.channels = channels
        if escalation_policy_target is not None:
            self.escalation_policy_target = escalation_policy_target
        if service_target is not None:
            self.service_target = service_target
        if user_target is not None:
            self.user_target = user_target
        if group_target is not None:
            self.group_target = group_target
        if schedule_target is not None:
            self.schedule_target = schedule_target

    @property
    def task_type(self):
        """Gets the task_type of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501


        :return: The task_type of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._task_type

    @task_type.setter
    def task_type(self, task_type):
        """Sets the task_type of this InviteToSlackChannelRootlyTaskParams.


        :param task_type: The task_type of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["invite_to_slack_channel_rootly"]  # noqa: E501
        if task_type not in allowed_values:
            raise ValueError(
                "Invalid value for `task_type` ({0}), must be one of {1}"  # noqa: E501
                .format(task_type, allowed_values)
            )

        self._task_type = task_type

    @property
    def channels(self):
        """Gets the channels of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501


        :return: The channels of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501
        :rtype: list[AddActionItemTaskParamsPostToSlackChannels]
        """
        return self._channels

    @channels.setter
    def channels(self, channels):
        """Sets the channels of this InviteToSlackChannelRootlyTaskParams.


        :param channels: The channels of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501
        :type: list[AddActionItemTaskParamsPostToSlackChannels]
        """

        self._channels = channels

    @property
    def escalation_policy_target(self):
        """Gets the escalation_policy_target of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501


        :return: The escalation_policy_target of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501
        :rtype: AddActionItemTaskParamsPostToSlackChannels
        """
        return self._escalation_policy_target

    @escalation_policy_target.setter
    def escalation_policy_target(self, escalation_policy_target):
        """Sets the escalation_policy_target of this InviteToSlackChannelRootlyTaskParams.


        :param escalation_policy_target: The escalation_policy_target of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501
        :type: AddActionItemTaskParamsPostToSlackChannels
        """

        self._escalation_policy_target = escalation_policy_target

    @property
    def service_target(self):
        """Gets the service_target of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501


        :return: The service_target of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501
        :rtype: AddActionItemTaskParamsPostToSlackChannels
        """
        return self._service_target

    @service_target.setter
    def service_target(self, service_target):
        """Sets the service_target of this InviteToSlackChannelRootlyTaskParams.


        :param service_target: The service_target of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501
        :type: AddActionItemTaskParamsPostToSlackChannels
        """

        self._service_target = service_target

    @property
    def user_target(self):
        """Gets the user_target of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501


        :return: The user_target of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501
        :rtype: AddActionItemTaskParamsPostToSlackChannels
        """
        return self._user_target

    @user_target.setter
    def user_target(self, user_target):
        """Sets the user_target of this InviteToSlackChannelRootlyTaskParams.


        :param user_target: The user_target of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501
        :type: AddActionItemTaskParamsPostToSlackChannels
        """

        self._user_target = user_target

    @property
    def group_target(self):
        """Gets the group_target of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501


        :return: The group_target of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501
        :rtype: AddActionItemTaskParamsPostToSlackChannels
        """
        return self._group_target

    @group_target.setter
    def group_target(self, group_target):
        """Sets the group_target of this InviteToSlackChannelRootlyTaskParams.


        :param group_target: The group_target of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501
        :type: AddActionItemTaskParamsPostToSlackChannels
        """

        self._group_target = group_target

    @property
    def schedule_target(self):
        """Gets the schedule_target of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501


        :return: The schedule_target of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501
        :rtype: AddActionItemTaskParamsPostToSlackChannels
        """
        return self._schedule_target

    @schedule_target.setter
    def schedule_target(self, schedule_target):
        """Sets the schedule_target of this InviteToSlackChannelRootlyTaskParams.


        :param schedule_target: The schedule_target of this InviteToSlackChannelRootlyTaskParams.  # noqa: E501
        :type: AddActionItemTaskParamsPostToSlackChannels
        """

        self._schedule_target = schedule_target

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InviteToSlackChannelRootlyTaskParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InviteToSlackChannelRootlyTaskParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
