# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class IpRanges(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'integrations_ipv4': 'list[str]',
        'integrations_ipv6': 'list[str]',
        'webhooks_ipv4': 'list[str]',
        'webhooks_ipv6': 'list[str]'
    }

    attribute_map = {
        'integrations_ipv4': 'integrations_ipv4',
        'integrations_ipv6': 'integrations_ipv6',
        'webhooks_ipv4': 'webhooks_ipv4',
        'webhooks_ipv6': 'webhooks_ipv6'
    }

    def __init__(self, integrations_ipv4=None, integrations_ipv6=None, webhooks_ipv4=None, webhooks_ipv6=None):  # noqa: E501
        """IpRanges - a model defined in Swagger"""  # noqa: E501
        self._integrations_ipv4 = None
        self._integrations_ipv6 = None
        self._webhooks_ipv4 = None
        self._webhooks_ipv6 = None
        self.discriminator = None
        self.integrations_ipv4 = integrations_ipv4
        self.integrations_ipv6 = integrations_ipv6
        self.webhooks_ipv4 = webhooks_ipv4
        self.webhooks_ipv6 = webhooks_ipv6

    @property
    def integrations_ipv4(self):
        """Gets the integrations_ipv4 of this IpRanges.  # noqa: E501

        IPv4 addresses associated with Rootly integrations.  # noqa: E501

        :return: The integrations_ipv4 of this IpRanges.  # noqa: E501
        :rtype: list[str]
        """
        return self._integrations_ipv4

    @integrations_ipv4.setter
    def integrations_ipv4(self, integrations_ipv4):
        """Sets the integrations_ipv4 of this IpRanges.

        IPv4 addresses associated with Rootly integrations.  # noqa: E501

        :param integrations_ipv4: The integrations_ipv4 of this IpRanges.  # noqa: E501
        :type: list[str]
        """
        if integrations_ipv4 is None:
            raise ValueError("Invalid value for `integrations_ipv4`, must not be `None`")  # noqa: E501

        self._integrations_ipv4 = integrations_ipv4

    @property
    def integrations_ipv6(self):
        """Gets the integrations_ipv6 of this IpRanges.  # noqa: E501

        IPv6 addresses associated with Rootly integrations.  # noqa: E501

        :return: The integrations_ipv6 of this IpRanges.  # noqa: E501
        :rtype: list[str]
        """
        return self._integrations_ipv6

    @integrations_ipv6.setter
    def integrations_ipv6(self, integrations_ipv6):
        """Sets the integrations_ipv6 of this IpRanges.

        IPv6 addresses associated with Rootly integrations.  # noqa: E501

        :param integrations_ipv6: The integrations_ipv6 of this IpRanges.  # noqa: E501
        :type: list[str]
        """
        if integrations_ipv6 is None:
            raise ValueError("Invalid value for `integrations_ipv6`, must not be `None`")  # noqa: E501

        self._integrations_ipv6 = integrations_ipv6

    @property
    def webhooks_ipv4(self):
        """Gets the webhooks_ipv4 of this IpRanges.  # noqa: E501

        IPv4 addresses associated with Rootly webhooks.  # noqa: E501

        :return: The webhooks_ipv4 of this IpRanges.  # noqa: E501
        :rtype: list[str]
        """
        return self._webhooks_ipv4

    @webhooks_ipv4.setter
    def webhooks_ipv4(self, webhooks_ipv4):
        """Sets the webhooks_ipv4 of this IpRanges.

        IPv4 addresses associated with Rootly webhooks.  # noqa: E501

        :param webhooks_ipv4: The webhooks_ipv4 of this IpRanges.  # noqa: E501
        :type: list[str]
        """
        if webhooks_ipv4 is None:
            raise ValueError("Invalid value for `webhooks_ipv4`, must not be `None`")  # noqa: E501

        self._webhooks_ipv4 = webhooks_ipv4

    @property
    def webhooks_ipv6(self):
        """Gets the webhooks_ipv6 of this IpRanges.  # noqa: E501

        IPv6 addresses associated with Rootly webhooks.  # noqa: E501

        :return: The webhooks_ipv6 of this IpRanges.  # noqa: E501
        :rtype: list[str]
        """
        return self._webhooks_ipv6

    @webhooks_ipv6.setter
    def webhooks_ipv6(self, webhooks_ipv6):
        """Sets the webhooks_ipv6 of this IpRanges.

        IPv6 addresses associated with Rootly webhooks.  # noqa: E501

        :param webhooks_ipv6: The webhooks_ipv6 of this IpRanges.  # noqa: E501
        :type: list[str]
        """
        if webhooks_ipv6 is None:
            raise ValueError("Invalid value for `webhooks_ipv6`, must not be `None`")  # noqa: E501

        self._webhooks_ipv6 = webhooks_ipv6

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IpRanges, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IpRanges):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
