# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class NewAlertGroupDataAttributes(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'time_window': 'int',
        'targets': 'list[NewAlertGroupDataAttributesTargets]',
        'attributes': 'list[NewAlertGroupDataAttributesAttributes]',
        'group_by_alert_title': 'int',
        'group_by_alert_urgency': 'int',
        'condition_type': 'str'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'time_window': 'time_window',
        'targets': 'targets',
        'attributes': 'attributes',
        'group_by_alert_title': 'group_by_alert_title',
        'group_by_alert_urgency': 'group_by_alert_urgency',
        'condition_type': 'condition_type'
    }

    def __init__(self, name=None, description=None, time_window=None, targets=None, attributes=None, group_by_alert_title=None, group_by_alert_urgency=None, condition_type=None):  # noqa: E501
        """NewAlertGroupDataAttributes - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._time_window = None
        self._targets = None
        self._attributes = None
        self._group_by_alert_title = None
        self._group_by_alert_urgency = None
        self._condition_type = None
        self.discriminator = None
        self.name = name
        if description is not None:
            self.description = description
        if time_window is not None:
            self.time_window = time_window
        self.targets = targets
        if attributes is not None:
            self.attributes = attributes
        if group_by_alert_title is not None:
            self.group_by_alert_title = group_by_alert_title
        if group_by_alert_urgency is not None:
            self.group_by_alert_urgency = group_by_alert_urgency
        if condition_type is not None:
            self.condition_type = condition_type

    @property
    def name(self):
        """Gets the name of this NewAlertGroupDataAttributes.  # noqa: E501

        The name of the alert group  # noqa: E501

        :return: The name of this NewAlertGroupDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this NewAlertGroupDataAttributes.

        The name of the alert group  # noqa: E501

        :param name: The name of this NewAlertGroupDataAttributes.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this NewAlertGroupDataAttributes.  # noqa: E501

        The description of the alert urgency  # noqa: E501

        :return: The description of this NewAlertGroupDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this NewAlertGroupDataAttributes.

        The description of the alert urgency  # noqa: E501

        :param description: The description of this NewAlertGroupDataAttributes.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def time_window(self):
        """Gets the time_window of this NewAlertGroupDataAttributes.  # noqa: E501

        The length of time an Alert Group should stay open and accept new alerts  # noqa: E501

        :return: The time_window of this NewAlertGroupDataAttributes.  # noqa: E501
        :rtype: int
        """
        return self._time_window

    @time_window.setter
    def time_window(self, time_window):
        """Sets the time_window of this NewAlertGroupDataAttributes.

        The length of time an Alert Group should stay open and accept new alerts  # noqa: E501

        :param time_window: The time_window of this NewAlertGroupDataAttributes.  # noqa: E501
        :type: int
        """

        self._time_window = time_window

    @property
    def targets(self):
        """Gets the targets of this NewAlertGroupDataAttributes.  # noqa: E501


        :return: The targets of this NewAlertGroupDataAttributes.  # noqa: E501
        :rtype: list[NewAlertGroupDataAttributesTargets]
        """
        return self._targets

    @targets.setter
    def targets(self, targets):
        """Sets the targets of this NewAlertGroupDataAttributes.


        :param targets: The targets of this NewAlertGroupDataAttributes.  # noqa: E501
        :type: list[NewAlertGroupDataAttributesTargets]
        """
        if targets is None:
            raise ValueError("Invalid value for `targets`, must not be `None`")  # noqa: E501

        self._targets = targets

    @property
    def attributes(self):
        """Gets the attributes of this NewAlertGroupDataAttributes.  # noqa: E501


        :return: The attributes of this NewAlertGroupDataAttributes.  # noqa: E501
        :rtype: list[NewAlertGroupDataAttributesAttributes]
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes):
        """Sets the attributes of this NewAlertGroupDataAttributes.


        :param attributes: The attributes of this NewAlertGroupDataAttributes.  # noqa: E501
        :type: list[NewAlertGroupDataAttributesAttributes]
        """

        self._attributes = attributes

    @property
    def group_by_alert_title(self):
        """Gets the group_by_alert_title of this NewAlertGroupDataAttributes.  # noqa: E501

        Whether the alerts should be grouped by titles.  # noqa: E501

        :return: The group_by_alert_title of this NewAlertGroupDataAttributes.  # noqa: E501
        :rtype: int
        """
        return self._group_by_alert_title

    @group_by_alert_title.setter
    def group_by_alert_title(self, group_by_alert_title):
        """Sets the group_by_alert_title of this NewAlertGroupDataAttributes.

        Whether the alerts should be grouped by titles.  # noqa: E501

        :param group_by_alert_title: The group_by_alert_title of this NewAlertGroupDataAttributes.  # noqa: E501
        :type: int
        """
        allowed_values = [1, 0]  # noqa: E501
        if group_by_alert_title not in allowed_values:
            raise ValueError(
                "Invalid value for `group_by_alert_title` ({0}), must be one of {1}"  # noqa: E501
                .format(group_by_alert_title, allowed_values)
            )

        self._group_by_alert_title = group_by_alert_title

    @property
    def group_by_alert_urgency(self):
        """Gets the group_by_alert_urgency of this NewAlertGroupDataAttributes.  # noqa: E501

        Whether the alerts should be grouped by urgencies.  # noqa: E501

        :return: The group_by_alert_urgency of this NewAlertGroupDataAttributes.  # noqa: E501
        :rtype: int
        """
        return self._group_by_alert_urgency

    @group_by_alert_urgency.setter
    def group_by_alert_urgency(self, group_by_alert_urgency):
        """Sets the group_by_alert_urgency of this NewAlertGroupDataAttributes.

        Whether the alerts should be grouped by urgencies.  # noqa: E501

        :param group_by_alert_urgency: The group_by_alert_urgency of this NewAlertGroupDataAttributes.  # noqa: E501
        :type: int
        """
        allowed_values = [1, 0]  # noqa: E501
        if group_by_alert_urgency not in allowed_values:
            raise ValueError(
                "Invalid value for `group_by_alert_urgency` ({0}), must be one of {1}"  # noqa: E501
                .format(group_by_alert_urgency, allowed_values)
            )

        self._group_by_alert_urgency = group_by_alert_urgency

    @property
    def condition_type(self):
        """Gets the condition_type of this NewAlertGroupDataAttributes.  # noqa: E501

        Group alerts when ANY or ALL of the fields are matching.  # noqa: E501

        :return: The condition_type of this NewAlertGroupDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._condition_type

    @condition_type.setter
    def condition_type(self, condition_type):
        """Sets the condition_type of this NewAlertGroupDataAttributes.

        Group alerts when ANY or ALL of the fields are matching.  # noqa: E501

        :param condition_type: The condition_type of this NewAlertGroupDataAttributes.  # noqa: E501
        :type: str
        """
        allowed_values = ["all", "any"]  # noqa: E501
        if condition_type not in allowed_values:
            raise ValueError(
                "Invalid value for `condition_type` ({0}), must be one of {1}"  # noqa: E501
                .format(condition_type, allowed_values)
            )

        self._condition_type = condition_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NewAlertGroupDataAttributes, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NewAlertGroupDataAttributes):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
