# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class NewAlertsSourceDataAttributesSourceableAttributes(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'auto_resolve': 'bool',
        'resolve_state': 'str',
        'field_mappings_attributes': 'list[NewAlertsSourceDataAttributesSourceableAttributesFieldMappingsAttributes]'
    }

    attribute_map = {
        'auto_resolve': 'auto_resolve',
        'resolve_state': 'resolve_state',
        'field_mappings_attributes': 'field_mappings_attributes'
    }

    def __init__(self, auto_resolve=None, resolve_state=None, field_mappings_attributes=None):  # noqa: E501
        """NewAlertsSourceDataAttributesSourceableAttributes - a model defined in Swagger"""  # noqa: E501
        self._auto_resolve = None
        self._resolve_state = None
        self._field_mappings_attributes = None
        self.discriminator = None
        if auto_resolve is not None:
            self.auto_resolve = auto_resolve
        if resolve_state is not None:
            self.resolve_state = resolve_state
        if field_mappings_attributes is not None:
            self.field_mappings_attributes = field_mappings_attributes

    @property
    def auto_resolve(self):
        """Gets the auto_resolve of this NewAlertsSourceDataAttributesSourceableAttributes.  # noqa: E501

        Set this to true to auto-resolve alerts based on field_mappings_attributes conditions  # noqa: E501

        :return: The auto_resolve of this NewAlertsSourceDataAttributesSourceableAttributes.  # noqa: E501
        :rtype: bool
        """
        return self._auto_resolve

    @auto_resolve.setter
    def auto_resolve(self, auto_resolve):
        """Sets the auto_resolve of this NewAlertsSourceDataAttributesSourceableAttributes.

        Set this to true to auto-resolve alerts based on field_mappings_attributes conditions  # noqa: E501

        :param auto_resolve: The auto_resolve of this NewAlertsSourceDataAttributesSourceableAttributes.  # noqa: E501
        :type: bool
        """

        self._auto_resolve = auto_resolve

    @property
    def resolve_state(self):
        """Gets the resolve_state of this NewAlertsSourceDataAttributesSourceableAttributes.  # noqa: E501

        This value is matched with the value extracted from alerts payload using JSON path in field_mappings_attributes  # noqa: E501

        :return: The resolve_state of this NewAlertsSourceDataAttributesSourceableAttributes.  # noqa: E501
        :rtype: str
        """
        return self._resolve_state

    @resolve_state.setter
    def resolve_state(self, resolve_state):
        """Sets the resolve_state of this NewAlertsSourceDataAttributesSourceableAttributes.

        This value is matched with the value extracted from alerts payload using JSON path in field_mappings_attributes  # noqa: E501

        :param resolve_state: The resolve_state of this NewAlertsSourceDataAttributesSourceableAttributes.  # noqa: E501
        :type: str
        """

        self._resolve_state = resolve_state

    @property
    def field_mappings_attributes(self):
        """Gets the field_mappings_attributes of this NewAlertsSourceDataAttributesSourceableAttributes.  # noqa: E501

        Specify rules to auto resolve alerts  # noqa: E501

        :return: The field_mappings_attributes of this NewAlertsSourceDataAttributesSourceableAttributes.  # noqa: E501
        :rtype: list[NewAlertsSourceDataAttributesSourceableAttributesFieldMappingsAttributes]
        """
        return self._field_mappings_attributes

    @field_mappings_attributes.setter
    def field_mappings_attributes(self, field_mappings_attributes):
        """Sets the field_mappings_attributes of this NewAlertsSourceDataAttributesSourceableAttributes.

        Specify rules to auto resolve alerts  # noqa: E501

        :param field_mappings_attributes: The field_mappings_attributes of this NewAlertsSourceDataAttributesSourceableAttributes.  # noqa: E501
        :type: list[NewAlertsSourceDataAttributesSourceableAttributesFieldMappingsAttributes]
        """

        self._field_mappings_attributes = field_mappings_attributes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NewAlertsSourceDataAttributesSourceableAttributes, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NewAlertsSourceDataAttributesSourceableAttributes):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
