# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class OverrideShift(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'schedule_id': 'str',
        'rotation_id': 'str',
        'starts_at': 'str',
        'ends_at': 'str',
        'is_override': 'bool',
        'created_at': 'str',
        'updated_at': 'str',
        'shift_override': 'AllOfoverrideShiftShiftOverride',
        'user': 'AllOfoverrideShiftUser'
    }

    attribute_map = {
        'schedule_id': 'schedule_id',
        'rotation_id': 'rotation_id',
        'starts_at': 'starts_at',
        'ends_at': 'ends_at',
        'is_override': 'is_override',
        'created_at': 'created_at',
        'updated_at': 'updated_at',
        'shift_override': 'shift_override',
        'user': 'user'
    }

    def __init__(self, schedule_id=None, rotation_id=None, starts_at=None, ends_at=None, is_override=None, created_at=None, updated_at=None, shift_override=None, user=None):  # noqa: E501
        """OverrideShift - a model defined in Swagger"""  # noqa: E501
        self._schedule_id = None
        self._rotation_id = None
        self._starts_at = None
        self._ends_at = None
        self._is_override = None
        self._created_at = None
        self._updated_at = None
        self._shift_override = None
        self._user = None
        self.discriminator = None
        self.schedule_id = schedule_id
        self.rotation_id = rotation_id
        self.starts_at = starts_at
        self.ends_at = ends_at
        self.is_override = is_override
        if created_at is not None:
            self.created_at = created_at
        if updated_at is not None:
            self.updated_at = updated_at
        if shift_override is not None:
            self.shift_override = shift_override
        if user is not None:
            self.user = user

    @property
    def schedule_id(self):
        """Gets the schedule_id of this OverrideShift.  # noqa: E501

        ID of schedule  # noqa: E501

        :return: The schedule_id of this OverrideShift.  # noqa: E501
        :rtype: str
        """
        return self._schedule_id

    @schedule_id.setter
    def schedule_id(self, schedule_id):
        """Sets the schedule_id of this OverrideShift.

        ID of schedule  # noqa: E501

        :param schedule_id: The schedule_id of this OverrideShift.  # noqa: E501
        :type: str
        """
        if schedule_id is None:
            raise ValueError("Invalid value for `schedule_id`, must not be `None`")  # noqa: E501

        self._schedule_id = schedule_id

    @property
    def rotation_id(self):
        """Gets the rotation_id of this OverrideShift.  # noqa: E501

        ID of rotation  # noqa: E501

        :return: The rotation_id of this OverrideShift.  # noqa: E501
        :rtype: str
        """
        return self._rotation_id

    @rotation_id.setter
    def rotation_id(self, rotation_id):
        """Sets the rotation_id of this OverrideShift.

        ID of rotation  # noqa: E501

        :param rotation_id: The rotation_id of this OverrideShift.  # noqa: E501
        :type: str
        """
        if rotation_id is None:
            raise ValueError("Invalid value for `rotation_id`, must not be `None`")  # noqa: E501

        self._rotation_id = rotation_id

    @property
    def starts_at(self):
        """Gets the starts_at of this OverrideShift.  # noqa: E501

        Start datetime of shift  # noqa: E501

        :return: The starts_at of this OverrideShift.  # noqa: E501
        :rtype: str
        """
        return self._starts_at

    @starts_at.setter
    def starts_at(self, starts_at):
        """Sets the starts_at of this OverrideShift.

        Start datetime of shift  # noqa: E501

        :param starts_at: The starts_at of this OverrideShift.  # noqa: E501
        :type: str
        """
        if starts_at is None:
            raise ValueError("Invalid value for `starts_at`, must not be `None`")  # noqa: E501

        self._starts_at = starts_at

    @property
    def ends_at(self):
        """Gets the ends_at of this OverrideShift.  # noqa: E501

        End datetime of shift  # noqa: E501

        :return: The ends_at of this OverrideShift.  # noqa: E501
        :rtype: str
        """
        return self._ends_at

    @ends_at.setter
    def ends_at(self, ends_at):
        """Sets the ends_at of this OverrideShift.

        End datetime of shift  # noqa: E501

        :param ends_at: The ends_at of this OverrideShift.  # noqa: E501
        :type: str
        """
        if ends_at is None:
            raise ValueError("Invalid value for `ends_at`, must not be `None`")  # noqa: E501

        self._ends_at = ends_at

    @property
    def is_override(self):
        """Gets the is_override of this OverrideShift.  # noqa: E501

        Denotes shift is an override shift  # noqa: E501

        :return: The is_override of this OverrideShift.  # noqa: E501
        :rtype: bool
        """
        return self._is_override

    @is_override.setter
    def is_override(self, is_override):
        """Sets the is_override of this OverrideShift.

        Denotes shift is an override shift  # noqa: E501

        :param is_override: The is_override of this OverrideShift.  # noqa: E501
        :type: bool
        """
        if is_override is None:
            raise ValueError("Invalid value for `is_override`, must not be `None`")  # noqa: E501

        self._is_override = is_override

    @property
    def created_at(self):
        """Gets the created_at of this OverrideShift.  # noqa: E501

        Date of creation  # noqa: E501

        :return: The created_at of this OverrideShift.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this OverrideShift.

        Date of creation  # noqa: E501

        :param created_at: The created_at of this OverrideShift.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this OverrideShift.  # noqa: E501

        Date of last update  # noqa: E501

        :return: The updated_at of this OverrideShift.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this OverrideShift.

        Date of last update  # noqa: E501

        :param updated_at: The updated_at of this OverrideShift.  # noqa: E501
        :type: str
        """

        self._updated_at = updated_at

    @property
    def shift_override(self):
        """Gets the shift_override of this OverrideShift.  # noqa: E501

        Override metadata  # noqa: E501

        :return: The shift_override of this OverrideShift.  # noqa: E501
        :rtype: AllOfoverrideShiftShiftOverride
        """
        return self._shift_override

    @shift_override.setter
    def shift_override(self, shift_override):
        """Sets the shift_override of this OverrideShift.

        Override metadata  # noqa: E501

        :param shift_override: The shift_override of this OverrideShift.  # noqa: E501
        :type: AllOfoverrideShiftShiftOverride
        """

        self._shift_override = shift_override

    @property
    def user(self):
        """Gets the user of this OverrideShift.  # noqa: E501

        User metadata  # noqa: E501

        :return: The user of this OverrideShift.  # noqa: E501
        :rtype: AllOfoverrideShiftUser
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this OverrideShift.

        User metadata  # noqa: E501

        :param user: The user of this OverrideShift.  # noqa: E501
        :type: AllOfoverrideShiftUser
        """

        self._user = user

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OverrideShift, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OverrideShift):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
