# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PageRootlyOnCallRespondersTaskParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'task_type': 'str',
        'escalation_policy_target': 'AddActionItemTaskParamsPostToSlackChannels',
        'service_target': 'AddActionItemTaskParamsPostToSlackChannels',
        'user_target': 'AddActionItemTaskParamsPostToSlackChannels',
        'group_target': 'AddActionItemTaskParamsPostToSlackChannels',
        'alert_urgency_id': 'str',
        'summary': 'str',
        'description': 'str',
        'escalation_note': 'str'
    }

    attribute_map = {
        'task_type': 'task_type',
        'escalation_policy_target': 'escalation_policy_target',
        'service_target': 'service_target',
        'user_target': 'user_target',
        'group_target': 'group_target',
        'alert_urgency_id': 'alert_urgency_id',
        'summary': 'summary',
        'description': 'description',
        'escalation_note': 'escalation_note'
    }

    def __init__(self, task_type=None, escalation_policy_target=None, service_target=None, user_target=None, group_target=None, alert_urgency_id=None, summary=None, description=None, escalation_note=None):  # noqa: E501
        """PageRootlyOnCallRespondersTaskParams - a model defined in Swagger"""  # noqa: E501
        self._task_type = None
        self._escalation_policy_target = None
        self._service_target = None
        self._user_target = None
        self._group_target = None
        self._alert_urgency_id = None
        self._summary = None
        self._description = None
        self._escalation_note = None
        self.discriminator = None
        if task_type is not None:
            self.task_type = task_type
        if escalation_policy_target is not None:
            self.escalation_policy_target = escalation_policy_target
        if service_target is not None:
            self.service_target = service_target
        if user_target is not None:
            self.user_target = user_target
        if group_target is not None:
            self.group_target = group_target
        if alert_urgency_id is not None:
            self.alert_urgency_id = alert_urgency_id
        self.summary = summary
        if description is not None:
            self.description = description
        if escalation_note is not None:
            self.escalation_note = escalation_note

    @property
    def task_type(self):
        """Gets the task_type of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501


        :return: The task_type of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._task_type

    @task_type.setter
    def task_type(self, task_type):
        """Sets the task_type of this PageRootlyOnCallRespondersTaskParams.


        :param task_type: The task_type of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["page_rootly_on_call_responders"]  # noqa: E501
        if task_type not in allowed_values:
            raise ValueError(
                "Invalid value for `task_type` ({0}), must be one of {1}"  # noqa: E501
                .format(task_type, allowed_values)
            )

        self._task_type = task_type

    @property
    def escalation_policy_target(self):
        """Gets the escalation_policy_target of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501


        :return: The escalation_policy_target of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :rtype: AddActionItemTaskParamsPostToSlackChannels
        """
        return self._escalation_policy_target

    @escalation_policy_target.setter
    def escalation_policy_target(self, escalation_policy_target):
        """Sets the escalation_policy_target of this PageRootlyOnCallRespondersTaskParams.


        :param escalation_policy_target: The escalation_policy_target of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :type: AddActionItemTaskParamsPostToSlackChannels
        """

        self._escalation_policy_target = escalation_policy_target

    @property
    def service_target(self):
        """Gets the service_target of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501


        :return: The service_target of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :rtype: AddActionItemTaskParamsPostToSlackChannels
        """
        return self._service_target

    @service_target.setter
    def service_target(self, service_target):
        """Sets the service_target of this PageRootlyOnCallRespondersTaskParams.


        :param service_target: The service_target of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :type: AddActionItemTaskParamsPostToSlackChannels
        """

        self._service_target = service_target

    @property
    def user_target(self):
        """Gets the user_target of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501


        :return: The user_target of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :rtype: AddActionItemTaskParamsPostToSlackChannels
        """
        return self._user_target

    @user_target.setter
    def user_target(self, user_target):
        """Sets the user_target of this PageRootlyOnCallRespondersTaskParams.


        :param user_target: The user_target of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :type: AddActionItemTaskParamsPostToSlackChannels
        """

        self._user_target = user_target

    @property
    def group_target(self):
        """Gets the group_target of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501


        :return: The group_target of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :rtype: AddActionItemTaskParamsPostToSlackChannels
        """
        return self._group_target

    @group_target.setter
    def group_target(self, group_target):
        """Sets the group_target of this PageRootlyOnCallRespondersTaskParams.


        :param group_target: The group_target of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :type: AddActionItemTaskParamsPostToSlackChannels
        """

        self._group_target = group_target

    @property
    def alert_urgency_id(self):
        """Gets the alert_urgency_id of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501

        Alert urgency ID  # noqa: E501

        :return: The alert_urgency_id of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._alert_urgency_id

    @alert_urgency_id.setter
    def alert_urgency_id(self, alert_urgency_id):
        """Sets the alert_urgency_id of this PageRootlyOnCallRespondersTaskParams.

        Alert urgency ID  # noqa: E501

        :param alert_urgency_id: The alert_urgency_id of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :type: str
        """

        self._alert_urgency_id = alert_urgency_id

    @property
    def summary(self):
        """Gets the summary of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501

        Alert title  # noqa: E501

        :return: The summary of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._summary

    @summary.setter
    def summary(self, summary):
        """Sets the summary of this PageRootlyOnCallRespondersTaskParams.

        Alert title  # noqa: E501

        :param summary: The summary of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :type: str
        """
        if summary is None:
            raise ValueError("Invalid value for `summary`, must not be `None`")  # noqa: E501

        self._summary = summary

    @property
    def description(self):
        """Gets the description of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501

        Alert description  # noqa: E501

        :return: The description of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this PageRootlyOnCallRespondersTaskParams.

        Alert description  # noqa: E501

        :param description: The description of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def escalation_note(self):
        """Gets the escalation_note of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501


        :return: The escalation_note of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._escalation_note

    @escalation_note.setter
    def escalation_note(self, escalation_note):
        """Sets the escalation_note of this PageRootlyOnCallRespondersTaskParams.


        :param escalation_note: The escalation_note of this PageRootlyOnCallRespondersTaskParams.  # noqa: E501
        :type: str
        """

        self._escalation_note = escalation_note

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PageRootlyOnCallRespondersTaskParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PageRootlyOnCallRespondersTaskParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
