# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PulseTriggerParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'trigger_type': 'str',
        'triggers': 'list[str]',
        'pulse_condition': 'str',
        'pulse_condition_source': 'str',
        'pulse_condition_source_use_regexp': 'bool',
        'pulse_sources': 'list[str]',
        'pulse_condition_label': 'str',
        'pulse_condition_label_use_regexp': 'bool',
        'pulse_labels': 'list[str]',
        'pulse_condition_payload': 'str',
        'pulse_condition_payload_use_regexp': 'bool',
        'pulse_payload': 'list[str]',
        'pulse_query_payload': 'str'
    }

    attribute_map = {
        'trigger_type': 'trigger_type',
        'triggers': 'triggers',
        'pulse_condition': 'pulse_condition',
        'pulse_condition_source': 'pulse_condition_source',
        'pulse_condition_source_use_regexp': 'pulse_condition_source_use_regexp',
        'pulse_sources': 'pulse_sources',
        'pulse_condition_label': 'pulse_condition_label',
        'pulse_condition_label_use_regexp': 'pulse_condition_label_use_regexp',
        'pulse_labels': 'pulse_labels',
        'pulse_condition_payload': 'pulse_condition_payload',
        'pulse_condition_payload_use_regexp': 'pulse_condition_payload_use_regexp',
        'pulse_payload': 'pulse_payload',
        'pulse_query_payload': 'pulse_query_payload'
    }

    def __init__(self, trigger_type=None, triggers=None, pulse_condition=None, pulse_condition_source='ANY', pulse_condition_source_use_regexp=False, pulse_sources=None, pulse_condition_label='ANY', pulse_condition_label_use_regexp=False, pulse_labels=None, pulse_condition_payload='ANY', pulse_condition_payload_use_regexp=False, pulse_payload=None, pulse_query_payload=None):  # noqa: E501
        """PulseTriggerParams - a model defined in Swagger"""  # noqa: E501
        self._trigger_type = None
        self._triggers = None
        self._pulse_condition = None
        self._pulse_condition_source = None
        self._pulse_condition_source_use_regexp = None
        self._pulse_sources = None
        self._pulse_condition_label = None
        self._pulse_condition_label_use_regexp = None
        self._pulse_labels = None
        self._pulse_condition_payload = None
        self._pulse_condition_payload_use_regexp = None
        self._pulse_payload = None
        self._pulse_query_payload = None
        self.discriminator = None
        self.trigger_type = trigger_type
        if triggers is not None:
            self.triggers = triggers
        if pulse_condition is not None:
            self.pulse_condition = pulse_condition
        if pulse_condition_source is not None:
            self.pulse_condition_source = pulse_condition_source
        if pulse_condition_source_use_regexp is not None:
            self.pulse_condition_source_use_regexp = pulse_condition_source_use_regexp
        if pulse_sources is not None:
            self.pulse_sources = pulse_sources
        if pulse_condition_label is not None:
            self.pulse_condition_label = pulse_condition_label
        if pulse_condition_label_use_regexp is not None:
            self.pulse_condition_label_use_regexp = pulse_condition_label_use_regexp
        if pulse_labels is not None:
            self.pulse_labels = pulse_labels
        if pulse_condition_payload is not None:
            self.pulse_condition_payload = pulse_condition_payload
        if pulse_condition_payload_use_regexp is not None:
            self.pulse_condition_payload_use_regexp = pulse_condition_payload_use_regexp
        if pulse_payload is not None:
            self.pulse_payload = pulse_payload
        if pulse_query_payload is not None:
            self.pulse_query_payload = pulse_query_payload

    @property
    def trigger_type(self):
        """Gets the trigger_type of this PulseTriggerParams.  # noqa: E501


        :return: The trigger_type of this PulseTriggerParams.  # noqa: E501
        :rtype: str
        """
        return self._trigger_type

    @trigger_type.setter
    def trigger_type(self, trigger_type):
        """Sets the trigger_type of this PulseTriggerParams.


        :param trigger_type: The trigger_type of this PulseTriggerParams.  # noqa: E501
        :type: str
        """
        if trigger_type is None:
            raise ValueError("Invalid value for `trigger_type`, must not be `None`")  # noqa: E501
        allowed_values = ["pulse"]  # noqa: E501
        if trigger_type not in allowed_values:
            raise ValueError(
                "Invalid value for `trigger_type` ({0}), must be one of {1}"  # noqa: E501
                .format(trigger_type, allowed_values)
            )

        self._trigger_type = trigger_type

    @property
    def triggers(self):
        """Gets the triggers of this PulseTriggerParams.  # noqa: E501


        :return: The triggers of this PulseTriggerParams.  # noqa: E501
        :rtype: list[str]
        """
        return self._triggers

    @triggers.setter
    def triggers(self, triggers):
        """Sets the triggers of this PulseTriggerParams.


        :param triggers: The triggers of this PulseTriggerParams.  # noqa: E501
        :type: list[str]
        """
        allowed_values = ["pulse_created"]  # noqa: E501
        if not set(triggers).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid values for `triggers` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(triggers) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._triggers = triggers

    @property
    def pulse_condition(self):
        """Gets the pulse_condition of this PulseTriggerParams.  # noqa: E501


        :return: The pulse_condition of this PulseTriggerParams.  # noqa: E501
        :rtype: str
        """
        return self._pulse_condition

    @pulse_condition.setter
    def pulse_condition(self, pulse_condition):
        """Sets the pulse_condition of this PulseTriggerParams.


        :param pulse_condition: The pulse_condition of this PulseTriggerParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["ALL", "ANY", "NONE"]  # noqa: E501
        if pulse_condition not in allowed_values:
            raise ValueError(
                "Invalid value for `pulse_condition` ({0}), must be one of {1}"  # noqa: E501
                .format(pulse_condition, allowed_values)
            )

        self._pulse_condition = pulse_condition

    @property
    def pulse_condition_source(self):
        """Gets the pulse_condition_source of this PulseTriggerParams.  # noqa: E501


        :return: The pulse_condition_source of this PulseTriggerParams.  # noqa: E501
        :rtype: str
        """
        return self._pulse_condition_source

    @pulse_condition_source.setter
    def pulse_condition_source(self, pulse_condition_source):
        """Sets the pulse_condition_source of this PulseTriggerParams.


        :param pulse_condition_source: The pulse_condition_source of this PulseTriggerParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["IS", "ANY", "CONTAINS", "CONTAINS_ALL", "CONTAINS_NONE", "NONE", "SET", "UNSET"]  # noqa: E501
        if pulse_condition_source not in allowed_values:
            raise ValueError(
                "Invalid value for `pulse_condition_source` ({0}), must be one of {1}"  # noqa: E501
                .format(pulse_condition_source, allowed_values)
            )

        self._pulse_condition_source = pulse_condition_source

    @property
    def pulse_condition_source_use_regexp(self):
        """Gets the pulse_condition_source_use_regexp of this PulseTriggerParams.  # noqa: E501


        :return: The pulse_condition_source_use_regexp of this PulseTriggerParams.  # noqa: E501
        :rtype: bool
        """
        return self._pulse_condition_source_use_regexp

    @pulse_condition_source_use_regexp.setter
    def pulse_condition_source_use_regexp(self, pulse_condition_source_use_regexp):
        """Sets the pulse_condition_source_use_regexp of this PulseTriggerParams.


        :param pulse_condition_source_use_regexp: The pulse_condition_source_use_regexp of this PulseTriggerParams.  # noqa: E501
        :type: bool
        """

        self._pulse_condition_source_use_regexp = pulse_condition_source_use_regexp

    @property
    def pulse_sources(self):
        """Gets the pulse_sources of this PulseTriggerParams.  # noqa: E501


        :return: The pulse_sources of this PulseTriggerParams.  # noqa: E501
        :rtype: list[str]
        """
        return self._pulse_sources

    @pulse_sources.setter
    def pulse_sources(self, pulse_sources):
        """Sets the pulse_sources of this PulseTriggerParams.


        :param pulse_sources: The pulse_sources of this PulseTriggerParams.  # noqa: E501
        :type: list[str]
        """

        self._pulse_sources = pulse_sources

    @property
    def pulse_condition_label(self):
        """Gets the pulse_condition_label of this PulseTriggerParams.  # noqa: E501


        :return: The pulse_condition_label of this PulseTriggerParams.  # noqa: E501
        :rtype: str
        """
        return self._pulse_condition_label

    @pulse_condition_label.setter
    def pulse_condition_label(self, pulse_condition_label):
        """Sets the pulse_condition_label of this PulseTriggerParams.


        :param pulse_condition_label: The pulse_condition_label of this PulseTriggerParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["IS", "ANY", "CONTAINS", "CONTAINS_ALL", "CONTAINS_NONE", "NONE", "SET", "UNSET"]  # noqa: E501
        if pulse_condition_label not in allowed_values:
            raise ValueError(
                "Invalid value for `pulse_condition_label` ({0}), must be one of {1}"  # noqa: E501
                .format(pulse_condition_label, allowed_values)
            )

        self._pulse_condition_label = pulse_condition_label

    @property
    def pulse_condition_label_use_regexp(self):
        """Gets the pulse_condition_label_use_regexp of this PulseTriggerParams.  # noqa: E501


        :return: The pulse_condition_label_use_regexp of this PulseTriggerParams.  # noqa: E501
        :rtype: bool
        """
        return self._pulse_condition_label_use_regexp

    @pulse_condition_label_use_regexp.setter
    def pulse_condition_label_use_regexp(self, pulse_condition_label_use_regexp):
        """Sets the pulse_condition_label_use_regexp of this PulseTriggerParams.


        :param pulse_condition_label_use_regexp: The pulse_condition_label_use_regexp of this PulseTriggerParams.  # noqa: E501
        :type: bool
        """

        self._pulse_condition_label_use_regexp = pulse_condition_label_use_regexp

    @property
    def pulse_labels(self):
        """Gets the pulse_labels of this PulseTriggerParams.  # noqa: E501


        :return: The pulse_labels of this PulseTriggerParams.  # noqa: E501
        :rtype: list[str]
        """
        return self._pulse_labels

    @pulse_labels.setter
    def pulse_labels(self, pulse_labels):
        """Sets the pulse_labels of this PulseTriggerParams.


        :param pulse_labels: The pulse_labels of this PulseTriggerParams.  # noqa: E501
        :type: list[str]
        """

        self._pulse_labels = pulse_labels

    @property
    def pulse_condition_payload(self):
        """Gets the pulse_condition_payload of this PulseTriggerParams.  # noqa: E501


        :return: The pulse_condition_payload of this PulseTriggerParams.  # noqa: E501
        :rtype: str
        """
        return self._pulse_condition_payload

    @pulse_condition_payload.setter
    def pulse_condition_payload(self, pulse_condition_payload):
        """Sets the pulse_condition_payload of this PulseTriggerParams.


        :param pulse_condition_payload: The pulse_condition_payload of this PulseTriggerParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["IS", "ANY", "CONTAINS", "CONTAINS_ALL", "CONTAINS_NONE", "NONE", "SET", "UNSET"]  # noqa: E501
        if pulse_condition_payload not in allowed_values:
            raise ValueError(
                "Invalid value for `pulse_condition_payload` ({0}), must be one of {1}"  # noqa: E501
                .format(pulse_condition_payload, allowed_values)
            )

        self._pulse_condition_payload = pulse_condition_payload

    @property
    def pulse_condition_payload_use_regexp(self):
        """Gets the pulse_condition_payload_use_regexp of this PulseTriggerParams.  # noqa: E501


        :return: The pulse_condition_payload_use_regexp of this PulseTriggerParams.  # noqa: E501
        :rtype: bool
        """
        return self._pulse_condition_payload_use_regexp

    @pulse_condition_payload_use_regexp.setter
    def pulse_condition_payload_use_regexp(self, pulse_condition_payload_use_regexp):
        """Sets the pulse_condition_payload_use_regexp of this PulseTriggerParams.


        :param pulse_condition_payload_use_regexp: The pulse_condition_payload_use_regexp of this PulseTriggerParams.  # noqa: E501
        :type: bool
        """

        self._pulse_condition_payload_use_regexp = pulse_condition_payload_use_regexp

    @property
    def pulse_payload(self):
        """Gets the pulse_payload of this PulseTriggerParams.  # noqa: E501


        :return: The pulse_payload of this PulseTriggerParams.  # noqa: E501
        :rtype: list[str]
        """
        return self._pulse_payload

    @pulse_payload.setter
    def pulse_payload(self, pulse_payload):
        """Sets the pulse_payload of this PulseTriggerParams.


        :param pulse_payload: The pulse_payload of this PulseTriggerParams.  # noqa: E501
        :type: list[str]
        """

        self._pulse_payload = pulse_payload

    @property
    def pulse_query_payload(self):
        """Gets the pulse_query_payload of this PulseTriggerParams.  # noqa: E501

        You can use jsonpath syntax. eg: $.incident.teams[*]  # noqa: E501

        :return: The pulse_query_payload of this PulseTriggerParams.  # noqa: E501
        :rtype: str
        """
        return self._pulse_query_payload

    @pulse_query_payload.setter
    def pulse_query_payload(self, pulse_query_payload):
        """Sets the pulse_query_payload of this PulseTriggerParams.

        You can use jsonpath syntax. eg: $.incident.teams[*]  # noqa: E501

        :param pulse_query_payload: The pulse_query_payload of this PulseTriggerParams.  # noqa: E501
        :type: str
        """

        self._pulse_query_payload = pulse_query_payload

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PulseTriggerParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PulseTriggerParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
