# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RetrospectiveConfiguration(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'kind': 'str',
        'severity_ids': 'list[str]',
        'group_ids': 'list[str]',
        'incident_type_ids': 'list[str]',
        'created_at': 'str',
        'updated_at': 'str'
    }

    attribute_map = {
        'kind': 'kind',
        'severity_ids': 'severity_ids',
        'group_ids': 'group_ids',
        'incident_type_ids': 'incident_type_ids',
        'created_at': 'created_at',
        'updated_at': 'updated_at'
    }

    def __init__(self, kind=None, severity_ids=None, group_ids=None, incident_type_ids=None, created_at=None, updated_at=None):  # noqa: E501
        """RetrospectiveConfiguration - a model defined in Swagger"""  # noqa: E501
        self._kind = None
        self._severity_ids = None
        self._group_ids = None
        self._incident_type_ids = None
        self._created_at = None
        self._updated_at = None
        self.discriminator = None
        if kind is not None:
            self.kind = kind
        if severity_ids is not None:
            self.severity_ids = severity_ids
        if group_ids is not None:
            self.group_ids = group_ids
        if incident_type_ids is not None:
            self.incident_type_ids = incident_type_ids
        if created_at is not None:
            self.created_at = created_at
        if updated_at is not None:
            self.updated_at = updated_at

    @property
    def kind(self):
        """Gets the kind of this RetrospectiveConfiguration.  # noqa: E501

        The kind of the configuration.  # noqa: E501

        :return: The kind of this RetrospectiveConfiguration.  # noqa: E501
        :rtype: str
        """
        return self._kind

    @kind.setter
    def kind(self, kind):
        """Sets the kind of this RetrospectiveConfiguration.

        The kind of the configuration.  # noqa: E501

        :param kind: The kind of this RetrospectiveConfiguration.  # noqa: E501
        :type: str
        """
        allowed_values = ["skip", "mandatory"]  # noqa: E501
        if kind not in allowed_values:
            raise ValueError(
                "Invalid value for `kind` ({0}), must be one of {1}"  # noqa: E501
                .format(kind, allowed_values)
            )

        self._kind = kind

    @property
    def severity_ids(self):
        """Gets the severity_ids of this RetrospectiveConfiguration.  # noqa: E501

        The Severity ID's to attach to the retrospective configuration  # noqa: E501

        :return: The severity_ids of this RetrospectiveConfiguration.  # noqa: E501
        :rtype: list[str]
        """
        return self._severity_ids

    @severity_ids.setter
    def severity_ids(self, severity_ids):
        """Sets the severity_ids of this RetrospectiveConfiguration.

        The Severity ID's to attach to the retrospective configuration  # noqa: E501

        :param severity_ids: The severity_ids of this RetrospectiveConfiguration.  # noqa: E501
        :type: list[str]
        """

        self._severity_ids = severity_ids

    @property
    def group_ids(self):
        """Gets the group_ids of this RetrospectiveConfiguration.  # noqa: E501

        The Team ID's to attach to the retrospective configuration  # noqa: E501

        :return: The group_ids of this RetrospectiveConfiguration.  # noqa: E501
        :rtype: list[str]
        """
        return self._group_ids

    @group_ids.setter
    def group_ids(self, group_ids):
        """Sets the group_ids of this RetrospectiveConfiguration.

        The Team ID's to attach to the retrospective configuration  # noqa: E501

        :param group_ids: The group_ids of this RetrospectiveConfiguration.  # noqa: E501
        :type: list[str]
        """

        self._group_ids = group_ids

    @property
    def incident_type_ids(self):
        """Gets the incident_type_ids of this RetrospectiveConfiguration.  # noqa: E501

        The Incident Type ID's to attach to the retrospective configuration  # noqa: E501

        :return: The incident_type_ids of this RetrospectiveConfiguration.  # noqa: E501
        :rtype: list[str]
        """
        return self._incident_type_ids

    @incident_type_ids.setter
    def incident_type_ids(self, incident_type_ids):
        """Sets the incident_type_ids of this RetrospectiveConfiguration.

        The Incident Type ID's to attach to the retrospective configuration  # noqa: E501

        :param incident_type_ids: The incident_type_ids of this RetrospectiveConfiguration.  # noqa: E501
        :type: list[str]
        """

        self._incident_type_ids = incident_type_ids

    @property
    def created_at(self):
        """Gets the created_at of this RetrospectiveConfiguration.  # noqa: E501

        Date of creation  # noqa: E501

        :return: The created_at of this RetrospectiveConfiguration.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this RetrospectiveConfiguration.

        Date of creation  # noqa: E501

        :param created_at: The created_at of this RetrospectiveConfiguration.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this RetrospectiveConfiguration.  # noqa: E501

        Date of last update  # noqa: E501

        :return: The updated_at of this RetrospectiveConfiguration.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this RetrospectiveConfiguration.

        Date of last update  # noqa: E501

        :param updated_at: The updated_at of this RetrospectiveConfiguration.  # noqa: E501
        :type: str
        """

        self._updated_at = updated_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RetrospectiveConfiguration, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RetrospectiveConfiguration):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
