# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ScheduleRotationActiveDay(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'schedule_rotation_id': 'str',
        'day_name': 'str',
        'active_time_attributes': 'list[NewScheduleRotationActiveDayDataAttributesActiveTimeAttributes]',
        'created_at': 'str',
        'updated_at': 'str'
    }

    attribute_map = {
        'schedule_rotation_id': 'schedule_rotation_id',
        'day_name': 'day_name',
        'active_time_attributes': 'active_time_attributes',
        'created_at': 'created_at',
        'updated_at': 'updated_at'
    }

    def __init__(self, schedule_rotation_id=None, day_name=None, active_time_attributes=None, created_at=None, updated_at=None):  # noqa: E501
        """ScheduleRotationActiveDay - a model defined in Swagger"""  # noqa: E501
        self._schedule_rotation_id = None
        self._day_name = None
        self._active_time_attributes = None
        self._created_at = None
        self._updated_at = None
        self.discriminator = None
        self.schedule_rotation_id = schedule_rotation_id
        self.day_name = day_name
        self.active_time_attributes = active_time_attributes
        self.created_at = created_at
        self.updated_at = updated_at

    @property
    def schedule_rotation_id(self):
        """Gets the schedule_rotation_id of this ScheduleRotationActiveDay.  # noqa: E501


        :return: The schedule_rotation_id of this ScheduleRotationActiveDay.  # noqa: E501
        :rtype: str
        """
        return self._schedule_rotation_id

    @schedule_rotation_id.setter
    def schedule_rotation_id(self, schedule_rotation_id):
        """Sets the schedule_rotation_id of this ScheduleRotationActiveDay.


        :param schedule_rotation_id: The schedule_rotation_id of this ScheduleRotationActiveDay.  # noqa: E501
        :type: str
        """
        if schedule_rotation_id is None:
            raise ValueError("Invalid value for `schedule_rotation_id`, must not be `None`")  # noqa: E501

        self._schedule_rotation_id = schedule_rotation_id

    @property
    def day_name(self):
        """Gets the day_name of this ScheduleRotationActiveDay.  # noqa: E501

        Schedule rotation day name for which active times to be created  # noqa: E501

        :return: The day_name of this ScheduleRotationActiveDay.  # noqa: E501
        :rtype: str
        """
        return self._day_name

    @day_name.setter
    def day_name(self, day_name):
        """Sets the day_name of this ScheduleRotationActiveDay.

        Schedule rotation day name for which active times to be created  # noqa: E501

        :param day_name: The day_name of this ScheduleRotationActiveDay.  # noqa: E501
        :type: str
        """
        if day_name is None:
            raise ValueError("Invalid value for `day_name`, must not be `None`")  # noqa: E501
        allowed_values = ["S", "M", "T", "W", "R", "F", "U"]  # noqa: E501
        if day_name not in allowed_values:
            raise ValueError(
                "Invalid value for `day_name` ({0}), must be one of {1}"  # noqa: E501
                .format(day_name, allowed_values)
            )

        self._day_name = day_name

    @property
    def active_time_attributes(self):
        """Gets the active_time_attributes of this ScheduleRotationActiveDay.  # noqa: E501

        Schedule rotation active times per day  # noqa: E501

        :return: The active_time_attributes of this ScheduleRotationActiveDay.  # noqa: E501
        :rtype: list[NewScheduleRotationActiveDayDataAttributesActiveTimeAttributes]
        """
        return self._active_time_attributes

    @active_time_attributes.setter
    def active_time_attributes(self, active_time_attributes):
        """Sets the active_time_attributes of this ScheduleRotationActiveDay.

        Schedule rotation active times per day  # noqa: E501

        :param active_time_attributes: The active_time_attributes of this ScheduleRotationActiveDay.  # noqa: E501
        :type: list[NewScheduleRotationActiveDayDataAttributesActiveTimeAttributes]
        """
        if active_time_attributes is None:
            raise ValueError("Invalid value for `active_time_attributes`, must not be `None`")  # noqa: E501

        self._active_time_attributes = active_time_attributes

    @property
    def created_at(self):
        """Gets the created_at of this ScheduleRotationActiveDay.  # noqa: E501

        Date of creation  # noqa: E501

        :return: The created_at of this ScheduleRotationActiveDay.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this ScheduleRotationActiveDay.

        Date of creation  # noqa: E501

        :param created_at: The created_at of this ScheduleRotationActiveDay.  # noqa: E501
        :type: str
        """
        if created_at is None:
            raise ValueError("Invalid value for `created_at`, must not be `None`")  # noqa: E501

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this ScheduleRotationActiveDay.  # noqa: E501

        Date of last update  # noqa: E501

        :return: The updated_at of this ScheduleRotationActiveDay.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this ScheduleRotationActiveDay.

        Date of last update  # noqa: E501

        :param updated_at: The updated_at of this ScheduleRotationActiveDay.  # noqa: E501
        :type: str
        """
        if updated_at is None:
            raise ValueError("Invalid value for `updated_at`, must not be `None`")  # noqa: E501

        self._updated_at = updated_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ScheduleRotationActiveDay, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScheduleRotationActiveDay):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
