# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UpdateAirtableTableRecordTaskParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'task_type': 'str',
        'base_key': 'str',
        'table_name': 'str',
        'record_id': 'str',
        'custom_fields_mapping': 'str'
    }

    attribute_map = {
        'task_type': 'task_type',
        'base_key': 'base_key',
        'table_name': 'table_name',
        'record_id': 'record_id',
        'custom_fields_mapping': 'custom_fields_mapping'
    }

    def __init__(self, task_type=None, base_key=None, table_name=None, record_id=None, custom_fields_mapping=None):  # noqa: E501
        """UpdateAirtableTableRecordTaskParams - a model defined in Swagger"""  # noqa: E501
        self._task_type = None
        self._base_key = None
        self._table_name = None
        self._record_id = None
        self._custom_fields_mapping = None
        self.discriminator = None
        if task_type is not None:
            self.task_type = task_type
        self.base_key = base_key
        self.table_name = table_name
        self.record_id = record_id
        if custom_fields_mapping is not None:
            self.custom_fields_mapping = custom_fields_mapping

    @property
    def task_type(self):
        """Gets the task_type of this UpdateAirtableTableRecordTaskParams.  # noqa: E501


        :return: The task_type of this UpdateAirtableTableRecordTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._task_type

    @task_type.setter
    def task_type(self, task_type):
        """Sets the task_type of this UpdateAirtableTableRecordTaskParams.


        :param task_type: The task_type of this UpdateAirtableTableRecordTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["update_airtable_table_record"]  # noqa: E501
        if task_type not in allowed_values:
            raise ValueError(
                "Invalid value for `task_type` ({0}), must be one of {1}"  # noqa: E501
                .format(task_type, allowed_values)
            )

        self._task_type = task_type

    @property
    def base_key(self):
        """Gets the base_key of this UpdateAirtableTableRecordTaskParams.  # noqa: E501

        The base key  # noqa: E501

        :return: The base_key of this UpdateAirtableTableRecordTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._base_key

    @base_key.setter
    def base_key(self, base_key):
        """Sets the base_key of this UpdateAirtableTableRecordTaskParams.

        The base key  # noqa: E501

        :param base_key: The base_key of this UpdateAirtableTableRecordTaskParams.  # noqa: E501
        :type: str
        """
        if base_key is None:
            raise ValueError("Invalid value for `base_key`, must not be `None`")  # noqa: E501

        self._base_key = base_key

    @property
    def table_name(self):
        """Gets the table_name of this UpdateAirtableTableRecordTaskParams.  # noqa: E501

        The table name  # noqa: E501

        :return: The table_name of this UpdateAirtableTableRecordTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._table_name

    @table_name.setter
    def table_name(self, table_name):
        """Sets the table_name of this UpdateAirtableTableRecordTaskParams.

        The table name  # noqa: E501

        :param table_name: The table_name of this UpdateAirtableTableRecordTaskParams.  # noqa: E501
        :type: str
        """
        if table_name is None:
            raise ValueError("Invalid value for `table_name`, must not be `None`")  # noqa: E501

        self._table_name = table_name

    @property
    def record_id(self):
        """Gets the record_id of this UpdateAirtableTableRecordTaskParams.  # noqa: E501

        The record id  # noqa: E501

        :return: The record_id of this UpdateAirtableTableRecordTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._record_id

    @record_id.setter
    def record_id(self, record_id):
        """Sets the record_id of this UpdateAirtableTableRecordTaskParams.

        The record id  # noqa: E501

        :param record_id: The record_id of this UpdateAirtableTableRecordTaskParams.  # noqa: E501
        :type: str
        """
        if record_id is None:
            raise ValueError("Invalid value for `record_id`, must not be `None`")  # noqa: E501

        self._record_id = record_id

    @property
    def custom_fields_mapping(self):
        """Gets the custom_fields_mapping of this UpdateAirtableTableRecordTaskParams.  # noqa: E501

        Custom field mappings. Can contain liquid markup and need to be valid JSON  # noqa: E501

        :return: The custom_fields_mapping of this UpdateAirtableTableRecordTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._custom_fields_mapping

    @custom_fields_mapping.setter
    def custom_fields_mapping(self, custom_fields_mapping):
        """Sets the custom_fields_mapping of this UpdateAirtableTableRecordTaskParams.

        Custom field mappings. Can contain liquid markup and need to be valid JSON  # noqa: E501

        :param custom_fields_mapping: The custom_fields_mapping of this UpdateAirtableTableRecordTaskParams.  # noqa: E501
        :type: str
        """

        self._custom_fields_mapping = custom_fields_mapping

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateAirtableTableRecordTaskParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateAirtableTableRecordTaskParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
