# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UpdateFormFieldOptionDataAttributes(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'value': 'str',
        'color': 'str',
        'default': 'bool',
        'position': 'int'
    }

    attribute_map = {
        'value': 'value',
        'color': 'color',
        'default': 'default',
        'position': 'position'
    }

    def __init__(self, value=None, color=None, default=None, position=None):  # noqa: E501
        """UpdateFormFieldOptionDataAttributes - a model defined in Swagger"""  # noqa: E501
        self._value = None
        self._color = None
        self._default = None
        self._position = None
        self.discriminator = None
        if value is not None:
            self.value = value
        if color is not None:
            self.color = color
        if default is not None:
            self.default = default
        if position is not None:
            self.position = position

    @property
    def value(self):
        """Gets the value of this UpdateFormFieldOptionDataAttributes.  # noqa: E501

        The value of the form_field_option  # noqa: E501

        :return: The value of this UpdateFormFieldOptionDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this UpdateFormFieldOptionDataAttributes.

        The value of the form_field_option  # noqa: E501

        :param value: The value of this UpdateFormFieldOptionDataAttributes.  # noqa: E501
        :type: str
        """

        self._value = value

    @property
    def color(self):
        """Gets the color of this UpdateFormFieldOptionDataAttributes.  # noqa: E501

        The hex color of the form_field_option  # noqa: E501

        :return: The color of this UpdateFormFieldOptionDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._color

    @color.setter
    def color(self, color):
        """Sets the color of this UpdateFormFieldOptionDataAttributes.

        The hex color of the form_field_option  # noqa: E501

        :param color: The color of this UpdateFormFieldOptionDataAttributes.  # noqa: E501
        :type: str
        """

        self._color = color

    @property
    def default(self):
        """Gets the default of this UpdateFormFieldOptionDataAttributes.  # noqa: E501


        :return: The default of this UpdateFormFieldOptionDataAttributes.  # noqa: E501
        :rtype: bool
        """
        return self._default

    @default.setter
    def default(self, default):
        """Sets the default of this UpdateFormFieldOptionDataAttributes.


        :param default: The default of this UpdateFormFieldOptionDataAttributes.  # noqa: E501
        :type: bool
        """

        self._default = default

    @property
    def position(self):
        """Gets the position of this UpdateFormFieldOptionDataAttributes.  # noqa: E501

        The position of the form_field_option  # noqa: E501

        :return: The position of this UpdateFormFieldOptionDataAttributes.  # noqa: E501
        :rtype: int
        """
        return self._position

    @position.setter
    def position(self, position):
        """Sets the position of this UpdateFormFieldOptionDataAttributes.

        The position of the form_field_option  # noqa: E501

        :param position: The position of this UpdateFormFieldOptionDataAttributes.  # noqa: E501
        :type: int
        """

        self._position = position

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateFormFieldOptionDataAttributes, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateFormFieldOptionDataAttributes):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
