# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UpdateFormFieldPlacementConditionDataAttributes(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'conditioned': 'str',
        'position': 'int',
        'form_field_id': 'str',
        'comparison': 'str',
        'values': 'list[str]'
    }

    attribute_map = {
        'conditioned': 'conditioned',
        'position': 'position',
        'form_field_id': 'form_field_id',
        'comparison': 'comparison',
        'values': 'values'
    }

    def __init__(self, conditioned=None, position=None, form_field_id=None, comparison=None, values=None):  # noqa: E501
        """UpdateFormFieldPlacementConditionDataAttributes - a model defined in Swagger"""  # noqa: E501
        self._conditioned = None
        self._position = None
        self._form_field_id = None
        self._comparison = None
        self._values = None
        self.discriminator = None
        if conditioned is not None:
            self.conditioned = conditioned
        if position is not None:
            self.position = position
        if form_field_id is not None:
            self.form_field_id = form_field_id
        if comparison is not None:
            self.comparison = comparison
        if values is not None:
            self.values = values

    @property
    def conditioned(self):
        """Gets the conditioned of this UpdateFormFieldPlacementConditionDataAttributes.  # noqa: E501

        The resource or attribute the condition applies.  # noqa: E501

        :return: The conditioned of this UpdateFormFieldPlacementConditionDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._conditioned

    @conditioned.setter
    def conditioned(self, conditioned):
        """Sets the conditioned of this UpdateFormFieldPlacementConditionDataAttributes.

        The resource or attribute the condition applies.  # noqa: E501

        :param conditioned: The conditioned of this UpdateFormFieldPlacementConditionDataAttributes.  # noqa: E501
        :type: str
        """
        allowed_values = ["placement", "required"]  # noqa: E501
        if conditioned not in allowed_values:
            raise ValueError(
                "Invalid value for `conditioned` ({0}), must be one of {1}"  # noqa: E501
                .format(conditioned, allowed_values)
            )

        self._conditioned = conditioned

    @property
    def position(self):
        """Gets the position of this UpdateFormFieldPlacementConditionDataAttributes.  # noqa: E501

        The condition position.  # noqa: E501

        :return: The position of this UpdateFormFieldPlacementConditionDataAttributes.  # noqa: E501
        :rtype: int
        """
        return self._position

    @position.setter
    def position(self, position):
        """Sets the position of this UpdateFormFieldPlacementConditionDataAttributes.

        The condition position.  # noqa: E501

        :param position: The position of this UpdateFormFieldPlacementConditionDataAttributes.  # noqa: E501
        :type: int
        """

        self._position = position

    @property
    def form_field_id(self):
        """Gets the form_field_id of this UpdateFormFieldPlacementConditionDataAttributes.  # noqa: E501

        The condition field.  # noqa: E501

        :return: The form_field_id of this UpdateFormFieldPlacementConditionDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._form_field_id

    @form_field_id.setter
    def form_field_id(self, form_field_id):
        """Sets the form_field_id of this UpdateFormFieldPlacementConditionDataAttributes.

        The condition field.  # noqa: E501

        :param form_field_id: The form_field_id of this UpdateFormFieldPlacementConditionDataAttributes.  # noqa: E501
        :type: str
        """

        self._form_field_id = form_field_id

    @property
    def comparison(self):
        """Gets the comparison of this UpdateFormFieldPlacementConditionDataAttributes.  # noqa: E501

        The condition comparison.  # noqa: E501

        :return: The comparison of this UpdateFormFieldPlacementConditionDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._comparison

    @comparison.setter
    def comparison(self, comparison):
        """Sets the comparison of this UpdateFormFieldPlacementConditionDataAttributes.

        The condition comparison.  # noqa: E501

        :param comparison: The comparison of this UpdateFormFieldPlacementConditionDataAttributes.  # noqa: E501
        :type: str
        """
        allowed_values = ["equal", "is_set", "is_not_set"]  # noqa: E501
        if comparison not in allowed_values:
            raise ValueError(
                "Invalid value for `comparison` ({0}), must be one of {1}"  # noqa: E501
                .format(comparison, allowed_values)
            )

        self._comparison = comparison

    @property
    def values(self):
        """Gets the values of this UpdateFormFieldPlacementConditionDataAttributes.  # noqa: E501

        The values for comparison.  # noqa: E501

        :return: The values of this UpdateFormFieldPlacementConditionDataAttributes.  # noqa: E501
        :rtype: list[str]
        """
        return self._values

    @values.setter
    def values(self, values):
        """Sets the values of this UpdateFormFieldPlacementConditionDataAttributes.

        The values for comparison.  # noqa: E501

        :param values: The values of this UpdateFormFieldPlacementConditionDataAttributes.  # noqa: E501
        :type: list[str]
        """

        self._values = values

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateFormFieldPlacementConditionDataAttributes, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateFormFieldPlacementConditionDataAttributes):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
