# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UpdateIncidentRoleDataAttributes(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'summary': 'str',
        'description': 'str',
        'position': 'int',
        'optional': 'bool',
        'enabled': 'bool',
        'allow_multi_user_assignment': 'bool'
    }

    attribute_map = {
        'name': 'name',
        'summary': 'summary',
        'description': 'description',
        'position': 'position',
        'optional': 'optional',
        'enabled': 'enabled',
        'allow_multi_user_assignment': 'allow_multi_user_assignment'
    }

    def __init__(self, name=None, summary=None, description=None, position=None, optional=None, enabled=None, allow_multi_user_assignment=None):  # noqa: E501
        """UpdateIncidentRoleDataAttributes - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._summary = None
        self._description = None
        self._position = None
        self._optional = None
        self._enabled = None
        self._allow_multi_user_assignment = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if summary is not None:
            self.summary = summary
        if description is not None:
            self.description = description
        if position is not None:
            self.position = position
        if optional is not None:
            self.optional = optional
        if enabled is not None:
            self.enabled = enabled
        if allow_multi_user_assignment is not None:
            self.allow_multi_user_assignment = allow_multi_user_assignment

    @property
    def name(self):
        """Gets the name of this UpdateIncidentRoleDataAttributes.  # noqa: E501

        The name of the incident role  # noqa: E501

        :return: The name of this UpdateIncidentRoleDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this UpdateIncidentRoleDataAttributes.

        The name of the incident role  # noqa: E501

        :param name: The name of this UpdateIncidentRoleDataAttributes.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def summary(self):
        """Gets the summary of this UpdateIncidentRoleDataAttributes.  # noqa: E501

        The summary of the incident role  # noqa: E501

        :return: The summary of this UpdateIncidentRoleDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._summary

    @summary.setter
    def summary(self, summary):
        """Sets the summary of this UpdateIncidentRoleDataAttributes.

        The summary of the incident role  # noqa: E501

        :param summary: The summary of this UpdateIncidentRoleDataAttributes.  # noqa: E501
        :type: str
        """

        self._summary = summary

    @property
    def description(self):
        """Gets the description of this UpdateIncidentRoleDataAttributes.  # noqa: E501

        The description of the incident role  # noqa: E501

        :return: The description of this UpdateIncidentRoleDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this UpdateIncidentRoleDataAttributes.

        The description of the incident role  # noqa: E501

        :param description: The description of this UpdateIncidentRoleDataAttributes.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def position(self):
        """Gets the position of this UpdateIncidentRoleDataAttributes.  # noqa: E501

        Position of the incident role  # noqa: E501

        :return: The position of this UpdateIncidentRoleDataAttributes.  # noqa: E501
        :rtype: int
        """
        return self._position

    @position.setter
    def position(self, position):
        """Sets the position of this UpdateIncidentRoleDataAttributes.

        Position of the incident role  # noqa: E501

        :param position: The position of this UpdateIncidentRoleDataAttributes.  # noqa: E501
        :type: int
        """

        self._position = position

    @property
    def optional(self):
        """Gets the optional of this UpdateIncidentRoleDataAttributes.  # noqa: E501


        :return: The optional of this UpdateIncidentRoleDataAttributes.  # noqa: E501
        :rtype: bool
        """
        return self._optional

    @optional.setter
    def optional(self, optional):
        """Sets the optional of this UpdateIncidentRoleDataAttributes.


        :param optional: The optional of this UpdateIncidentRoleDataAttributes.  # noqa: E501
        :type: bool
        """

        self._optional = optional

    @property
    def enabled(self):
        """Gets the enabled of this UpdateIncidentRoleDataAttributes.  # noqa: E501


        :return: The enabled of this UpdateIncidentRoleDataAttributes.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this UpdateIncidentRoleDataAttributes.


        :param enabled: The enabled of this UpdateIncidentRoleDataAttributes.  # noqa: E501
        :type: bool
        """

        self._enabled = enabled

    @property
    def allow_multi_user_assignment(self):
        """Gets the allow_multi_user_assignment of this UpdateIncidentRoleDataAttributes.  # noqa: E501


        :return: The allow_multi_user_assignment of this UpdateIncidentRoleDataAttributes.  # noqa: E501
        :rtype: bool
        """
        return self._allow_multi_user_assignment

    @allow_multi_user_assignment.setter
    def allow_multi_user_assignment(self, allow_multi_user_assignment):
        """Sets the allow_multi_user_assignment of this UpdateIncidentRoleDataAttributes.


        :param allow_multi_user_assignment: The allow_multi_user_assignment of this UpdateIncidentRoleDataAttributes.  # noqa: E501
        :type: bool
        """

        self._allow_multi_user_assignment = allow_multi_user_assignment

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateIncidentRoleDataAttributes, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateIncidentRoleDataAttributes):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
