# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UpdateIncidentSubStatusDataAttributes(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'sub_status_id': 'str',
        'assigned_at': 'str',
        'assigned_by_user_id': 'int'
    }

    attribute_map = {
        'sub_status_id': 'sub_status_id',
        'assigned_at': 'assigned_at',
        'assigned_by_user_id': 'assigned_by_user_id'
    }

    def __init__(self, sub_status_id=None, assigned_at=None, assigned_by_user_id=None):  # noqa: E501
        """UpdateIncidentSubStatusDataAttributes - a model defined in Swagger"""  # noqa: E501
        self._sub_status_id = None
        self._assigned_at = None
        self._assigned_by_user_id = None
        self.discriminator = None
        if sub_status_id is not None:
            self.sub_status_id = sub_status_id
        if assigned_at is not None:
            self.assigned_at = assigned_at
        if assigned_by_user_id is not None:
            self.assigned_by_user_id = assigned_by_user_id

    @property
    def sub_status_id(self):
        """Gets the sub_status_id of this UpdateIncidentSubStatusDataAttributes.  # noqa: E501

        Note: To change an incident's sub-status, use the PATCH /incidents/:id endpoint and set the sub_status_id attribute. This endpoint is for modifying the timestamp of when an incident's sub-status was assigned.  # noqa: E501

        :return: The sub_status_id of this UpdateIncidentSubStatusDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._sub_status_id

    @sub_status_id.setter
    def sub_status_id(self, sub_status_id):
        """Sets the sub_status_id of this UpdateIncidentSubStatusDataAttributes.

        Note: To change an incident's sub-status, use the PATCH /incidents/:id endpoint and set the sub_status_id attribute. This endpoint is for modifying the timestamp of when an incident's sub-status was assigned.  # noqa: E501

        :param sub_status_id: The sub_status_id of this UpdateIncidentSubStatusDataAttributes.  # noqa: E501
        :type: str
        """

        self._sub_status_id = sub_status_id

    @property
    def assigned_at(self):
        """Gets the assigned_at of this UpdateIncidentSubStatusDataAttributes.  # noqa: E501


        :return: The assigned_at of this UpdateIncidentSubStatusDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._assigned_at

    @assigned_at.setter
    def assigned_at(self, assigned_at):
        """Sets the assigned_at of this UpdateIncidentSubStatusDataAttributes.


        :param assigned_at: The assigned_at of this UpdateIncidentSubStatusDataAttributes.  # noqa: E501
        :type: str
        """

        self._assigned_at = assigned_at

    @property
    def assigned_by_user_id(self):
        """Gets the assigned_by_user_id of this UpdateIncidentSubStatusDataAttributes.  # noqa: E501


        :return: The assigned_by_user_id of this UpdateIncidentSubStatusDataAttributes.  # noqa: E501
        :rtype: int
        """
        return self._assigned_by_user_id

    @assigned_by_user_id.setter
    def assigned_by_user_id(self, assigned_by_user_id):
        """Sets the assigned_by_user_id of this UpdateIncidentSubStatusDataAttributes.


        :param assigned_by_user_id: The assigned_by_user_id of this UpdateIncidentSubStatusDataAttributes.  # noqa: E501
        :type: int
        """

        self._assigned_by_user_id = assigned_by_user_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateIncidentSubStatusDataAttributes, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateIncidentSubStatusDataAttributes):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
