# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UpdateOpsgenieAlertTaskParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'alert_id': 'str',
        'task_type': 'str',
        'message': 'str',
        'description': 'str',
        'priority': 'str',
        'completion': 'AddActionItemTaskParamsPostToSlackChannels'
    }

    attribute_map = {
        'alert_id': 'alert_id',
        'task_type': 'task_type',
        'message': 'message',
        'description': 'description',
        'priority': 'priority',
        'completion': 'completion'
    }

    def __init__(self, alert_id=None, task_type=None, message=None, description=None, priority=None, completion=None):  # noqa: E501
        """UpdateOpsgenieAlertTaskParams - a model defined in Swagger"""  # noqa: E501
        self._alert_id = None
        self._task_type = None
        self._message = None
        self._description = None
        self._priority = None
        self._completion = None
        self.discriminator = None
        self.alert_id = alert_id
        if task_type is not None:
            self.task_type = task_type
        if message is not None:
            self.message = message
        if description is not None:
            self.description = description
        self.priority = priority
        self.completion = completion

    @property
    def alert_id(self):
        """Gets the alert_id of this UpdateOpsgenieAlertTaskParams.  # noqa: E501

        Opsgenie Alert ID  # noqa: E501

        :return: The alert_id of this UpdateOpsgenieAlertTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._alert_id

    @alert_id.setter
    def alert_id(self, alert_id):
        """Sets the alert_id of this UpdateOpsgenieAlertTaskParams.

        Opsgenie Alert ID  # noqa: E501

        :param alert_id: The alert_id of this UpdateOpsgenieAlertTaskParams.  # noqa: E501
        :type: str
        """
        if alert_id is None:
            raise ValueError("Invalid value for `alert_id`, must not be `None`")  # noqa: E501

        self._alert_id = alert_id

    @property
    def task_type(self):
        """Gets the task_type of this UpdateOpsgenieAlertTaskParams.  # noqa: E501


        :return: The task_type of this UpdateOpsgenieAlertTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._task_type

    @task_type.setter
    def task_type(self, task_type):
        """Sets the task_type of this UpdateOpsgenieAlertTaskParams.


        :param task_type: The task_type of this UpdateOpsgenieAlertTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["update_opsgenie_alert"]  # noqa: E501
        if task_type not in allowed_values:
            raise ValueError(
                "Invalid value for `task_type` ({0}), must be one of {1}"  # noqa: E501
                .format(task_type, allowed_values)
            )

        self._task_type = task_type

    @property
    def message(self):
        """Gets the message of this UpdateOpsgenieAlertTaskParams.  # noqa: E501

        Message of the alert  # noqa: E501

        :return: The message of this UpdateOpsgenieAlertTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this UpdateOpsgenieAlertTaskParams.

        Message of the alert  # noqa: E501

        :param message: The message of this UpdateOpsgenieAlertTaskParams.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def description(self):
        """Gets the description of this UpdateOpsgenieAlertTaskParams.  # noqa: E501

        Description field of the alert that is generally used to provide a detailed information about the alert  # noqa: E501

        :return: The description of this UpdateOpsgenieAlertTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this UpdateOpsgenieAlertTaskParams.

        Description field of the alert that is generally used to provide a detailed information about the alert  # noqa: E501

        :param description: The description of this UpdateOpsgenieAlertTaskParams.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def priority(self):
        """Gets the priority of this UpdateOpsgenieAlertTaskParams.  # noqa: E501


        :return: The priority of this UpdateOpsgenieAlertTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._priority

    @priority.setter
    def priority(self, priority):
        """Sets the priority of this UpdateOpsgenieAlertTaskParams.


        :param priority: The priority of this UpdateOpsgenieAlertTaskParams.  # noqa: E501
        :type: str
        """
        if priority is None:
            raise ValueError("Invalid value for `priority`, must not be `None`")  # noqa: E501
        allowed_values = ["P1", "P2", "P3", "P4", "P5", "auto"]  # noqa: E501
        if priority not in allowed_values:
            raise ValueError(
                "Invalid value for `priority` ({0}), must be one of {1}"  # noqa: E501
                .format(priority, allowed_values)
            )

        self._priority = priority

    @property
    def completion(self):
        """Gets the completion of this UpdateOpsgenieAlertTaskParams.  # noqa: E501


        :return: The completion of this UpdateOpsgenieAlertTaskParams.  # noqa: E501
        :rtype: AddActionItemTaskParamsPostToSlackChannels
        """
        return self._completion

    @completion.setter
    def completion(self, completion):
        """Sets the completion of this UpdateOpsgenieAlertTaskParams.


        :param completion: The completion of this UpdateOpsgenieAlertTaskParams.  # noqa: E501
        :type: AddActionItemTaskParamsPostToSlackChannels
        """
        if completion is None:
            raise ValueError("Invalid value for `completion`, must not be `None`")  # noqa: E501

        self._completion = completion

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateOpsgenieAlertTaskParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateOpsgenieAlertTaskParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
