# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UpdatePagertreeAlertTaskParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'task_type': 'str',
        'pagertree_alert_id': 'str',
        'title': 'str',
        'description': 'str',
        'urgency': 'str',
        'severity': 'str',
        'teams': 'list[AddActionItemTaskParamsPostToSlackChannels]',
        'users': 'list[AddActionItemTaskParamsPostToSlackChannels]',
        'incident': 'bool'
    }

    attribute_map = {
        'task_type': 'task_type',
        'pagertree_alert_id': 'pagertree_alert_id',
        'title': 'title',
        'description': 'description',
        'urgency': 'urgency',
        'severity': 'severity',
        'teams': 'teams',
        'users': 'users',
        'incident': 'incident'
    }

    def __init__(self, task_type=None, pagertree_alert_id=None, title=None, description=None, urgency=None, severity=None, teams=None, users=None, incident=None):  # noqa: E501
        """UpdatePagertreeAlertTaskParams - a model defined in Swagger"""  # noqa: E501
        self._task_type = None
        self._pagertree_alert_id = None
        self._title = None
        self._description = None
        self._urgency = None
        self._severity = None
        self._teams = None
        self._users = None
        self._incident = None
        self.discriminator = None
        if task_type is not None:
            self.task_type = task_type
        if pagertree_alert_id is not None:
            self.pagertree_alert_id = pagertree_alert_id
        if title is not None:
            self.title = title
        if description is not None:
            self.description = description
        if urgency is not None:
            self.urgency = urgency
        if severity is not None:
            self.severity = severity
        if teams is not None:
            self.teams = teams
        if users is not None:
            self.users = users
        if incident is not None:
            self.incident = incident

    @property
    def task_type(self):
        """Gets the task_type of this UpdatePagertreeAlertTaskParams.  # noqa: E501


        :return: The task_type of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._task_type

    @task_type.setter
    def task_type(self, task_type):
        """Sets the task_type of this UpdatePagertreeAlertTaskParams.


        :param task_type: The task_type of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["update_pagertree_alert"]  # noqa: E501
        if task_type not in allowed_values:
            raise ValueError(
                "Invalid value for `task_type` ({0}), must be one of {1}"  # noqa: E501
                .format(task_type, allowed_values)
            )

        self._task_type = task_type

    @property
    def pagertree_alert_id(self):
        """Gets the pagertree_alert_id of this UpdatePagertreeAlertTaskParams.  # noqa: E501

        The prefix ID of the Pagertree alert  # noqa: E501

        :return: The pagertree_alert_id of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._pagertree_alert_id

    @pagertree_alert_id.setter
    def pagertree_alert_id(self, pagertree_alert_id):
        """Sets the pagertree_alert_id of this UpdatePagertreeAlertTaskParams.

        The prefix ID of the Pagertree alert  # noqa: E501

        :param pagertree_alert_id: The pagertree_alert_id of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :type: str
        """

        self._pagertree_alert_id = pagertree_alert_id

    @property
    def title(self):
        """Gets the title of this UpdatePagertreeAlertTaskParams.  # noqa: E501

        Title of alert as text  # noqa: E501

        :return: The title of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this UpdatePagertreeAlertTaskParams.

        Title of alert as text  # noqa: E501

        :param title: The title of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :type: str
        """

        self._title = title

    @property
    def description(self):
        """Gets the description of this UpdatePagertreeAlertTaskParams.  # noqa: E501

        Description of alert as text  # noqa: E501

        :return: The description of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this UpdatePagertreeAlertTaskParams.

        Description of alert as text  # noqa: E501

        :param description: The description of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def urgency(self):
        """Gets the urgency of this UpdatePagertreeAlertTaskParams.  # noqa: E501


        :return: The urgency of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._urgency

    @urgency.setter
    def urgency(self, urgency):
        """Sets the urgency of this UpdatePagertreeAlertTaskParams.


        :param urgency: The urgency of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["auto", "critical", "high", "medium", "low"]  # noqa: E501
        if urgency not in allowed_values:
            raise ValueError(
                "Invalid value for `urgency` ({0}), must be one of {1}"  # noqa: E501
                .format(urgency, allowed_values)
            )

        self._urgency = urgency

    @property
    def severity(self):
        """Gets the severity of this UpdatePagertreeAlertTaskParams.  # noqa: E501


        :return: The severity of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._severity

    @severity.setter
    def severity(self, severity):
        """Sets the severity of this UpdatePagertreeAlertTaskParams.


        :param severity: The severity of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["auto", "SEV-1", "SEV-2", "SEV-3", "SEV-4"]  # noqa: E501
        if severity not in allowed_values:
            raise ValueError(
                "Invalid value for `severity` ({0}), must be one of {1}"  # noqa: E501
                .format(severity, allowed_values)
            )

        self._severity = severity

    @property
    def teams(self):
        """Gets the teams of this UpdatePagertreeAlertTaskParams.  # noqa: E501


        :return: The teams of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :rtype: list[AddActionItemTaskParamsPostToSlackChannels]
        """
        return self._teams

    @teams.setter
    def teams(self, teams):
        """Sets the teams of this UpdatePagertreeAlertTaskParams.


        :param teams: The teams of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :type: list[AddActionItemTaskParamsPostToSlackChannels]
        """

        self._teams = teams

    @property
    def users(self):
        """Gets the users of this UpdatePagertreeAlertTaskParams.  # noqa: E501


        :return: The users of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :rtype: list[AddActionItemTaskParamsPostToSlackChannels]
        """
        return self._users

    @users.setter
    def users(self, users):
        """Sets the users of this UpdatePagertreeAlertTaskParams.


        :param users: The users of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :type: list[AddActionItemTaskParamsPostToSlackChannels]
        """

        self._users = users

    @property
    def incident(self):
        """Gets the incident of this UpdatePagertreeAlertTaskParams.  # noqa: E501

        Setting to true makes an alert a Pagertree incident  # noqa: E501

        :return: The incident of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :rtype: bool
        """
        return self._incident

    @incident.setter
    def incident(self, incident):
        """Sets the incident of this UpdatePagertreeAlertTaskParams.

        Setting to true makes an alert a Pagertree incident  # noqa: E501

        :param incident: The incident of this UpdatePagertreeAlertTaskParams.  # noqa: E501
        :type: bool
        """

        self._incident = incident

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdatePagertreeAlertTaskParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdatePagertreeAlertTaskParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
