# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UpdatePostMortemTemplateDataAttributes(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'default': 'bool',
        'content': 'str',
        'format': 'str'
    }

    attribute_map = {
        'name': 'name',
        'default': 'default',
        'content': 'content',
        'format': 'format'
    }

    def __init__(self, name=None, default=None, content=None, format='html'):  # noqa: E501
        """UpdatePostMortemTemplateDataAttributes - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._default = None
        self._content = None
        self._format = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if default is not None:
            self.default = default
        if content is not None:
            self.content = content
        if format is not None:
            self.format = format

    @property
    def name(self):
        """Gets the name of this UpdatePostMortemTemplateDataAttributes.  # noqa: E501

        The name of the postmortem template  # noqa: E501

        :return: The name of this UpdatePostMortemTemplateDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this UpdatePostMortemTemplateDataAttributes.

        The name of the postmortem template  # noqa: E501

        :param name: The name of this UpdatePostMortemTemplateDataAttributes.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def default(self):
        """Gets the default of this UpdatePostMortemTemplateDataAttributes.  # noqa: E501

        Default selected template when editing a postmortem  # noqa: E501

        :return: The default of this UpdatePostMortemTemplateDataAttributes.  # noqa: E501
        :rtype: bool
        """
        return self._default

    @default.setter
    def default(self, default):
        """Sets the default of this UpdatePostMortemTemplateDataAttributes.

        Default selected template when editing a postmortem  # noqa: E501

        :param default: The default of this UpdatePostMortemTemplateDataAttributes.  # noqa: E501
        :type: bool
        """

        self._default = default

    @property
    def content(self):
        """Gets the content of this UpdatePostMortemTemplateDataAttributes.  # noqa: E501

        The postmortem template. Liquid syntax is supported  # noqa: E501

        :return: The content of this UpdatePostMortemTemplateDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._content

    @content.setter
    def content(self, content):
        """Sets the content of this UpdatePostMortemTemplateDataAttributes.

        The postmortem template. Liquid syntax is supported  # noqa: E501

        :param content: The content of this UpdatePostMortemTemplateDataAttributes.  # noqa: E501
        :type: str
        """

        self._content = content

    @property
    def format(self):
        """Gets the format of this UpdatePostMortemTemplateDataAttributes.  # noqa: E501

        The format of the input  # noqa: E501

        :return: The format of this UpdatePostMortemTemplateDataAttributes.  # noqa: E501
        :rtype: str
        """
        return self._format

    @format.setter
    def format(self, format):
        """Sets the format of this UpdatePostMortemTemplateDataAttributes.

        The format of the input  # noqa: E501

        :param format: The format of this UpdatePostMortemTemplateDataAttributes.  # noqa: E501
        :type: str
        """
        allowed_values = ["html", "markdown"]  # noqa: E501
        if format not in allowed_values:
            raise ValueError(
                "Invalid value for `format` ({0}), must be one of {1}"  # noqa: E501
                .format(format, allowed_values)
            )

        self._format = format

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdatePostMortemTemplateDataAttributes, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdatePostMortemTemplateDataAttributes):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
