# coding: utf-8

"""
    Rootly API v1

    # How to generate an API Key? - **Account** > **Manage API keys** > **Generate New API Key**  # JSON:API Specification Rootly is using **JSON:API** (https://jsonapi.org) specification: - JSON:API is a specification for how a client should request that resources be fetched or modified, and how a server should respond to those requests. - JSON:API is designed to minimize both the number of requests and the amount of data transmitted between clients and servers. This efficiency is achieved without compromising readability, flexibility, or discoverability. - JSON:API requires use of the JSON:API media type (**application/vnd.api+json**) for exchanging data.  # Authentication and Requests We use standard HTTP Authentication over HTTPS to authorize your requests. ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents ```  <br/>  # Rate limiting - There is a default limit of approximately **3000** **GET** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - There is a default limit of approximately **3000** **PUT**, **POST**, **PATCH** or **DELETE** calls **per API key** every **60 seconds**. The limit is calculated over a **60-second sliding window** looking back from the current time. While the limit can be configured to support higher thresholds, you must first contact your **Rootly Customer Success Manager** to make any adjustments. - The response to the API call will return 429 HTTP status code - Request Limit Exceeded and Rootly will not ingest the event. - Additional headers will be returned giving you information about the limit:   - **RateLimit-Limit** - The maximum number of requests that the consumer is permitted to make.   - **RateLimit-Remaining** - The number of requests remaining in the current rate limit window.   - **RateLimit-Reset** - The time at which the current rate limit window resets in UTC epoch seconds.  # Pagination - Pagination is supported for all endpoints that return a collection of items. - Pagination is controlled by the **page** query parameter  ## Example ```   curl --request GET \\ --header 'Content-Type: application/vnd.api+json' \\ --header 'Authorization: Bearer YOUR-TOKEN' \\ --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10 ```    # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UpdateTrelloCardTaskParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'task_type': 'str',
        'card_id': 'str',
        'title': 'str',
        'description': 'str',
        'due_date': 'str',
        'board': 'CreateTrelloCardTaskParamsBoard',
        'list': 'CreateTrelloCardTaskParamsList',
        'labels': 'list[AddActionItemTaskParamsPostToSlackChannels]',
        'archivation': 'CreateShortcutStoryTaskParamsArchivation'
    }

    attribute_map = {
        'task_type': 'task_type',
        'card_id': 'card_id',
        'title': 'title',
        'description': 'description',
        'due_date': 'due_date',
        'board': 'board',
        'list': 'list',
        'labels': 'labels',
        'archivation': 'archivation'
    }

    def __init__(self, task_type=None, card_id=None, title=None, description=None, due_date=None, board=None, list=None, labels=None, archivation=None):  # noqa: E501
        """UpdateTrelloCardTaskParams - a model defined in Swagger"""  # noqa: E501
        self._task_type = None
        self._card_id = None
        self._title = None
        self._description = None
        self._due_date = None
        self._board = None
        self._list = None
        self._labels = None
        self._archivation = None
        self.discriminator = None
        if task_type is not None:
            self.task_type = task_type
        self.card_id = card_id
        if title is not None:
            self.title = title
        if description is not None:
            self.description = description
        if due_date is not None:
            self.due_date = due_date
        if board is not None:
            self.board = board
        if list is not None:
            self.list = list
        if labels is not None:
            self.labels = labels
        self.archivation = archivation

    @property
    def task_type(self):
        """Gets the task_type of this UpdateTrelloCardTaskParams.  # noqa: E501


        :return: The task_type of this UpdateTrelloCardTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._task_type

    @task_type.setter
    def task_type(self, task_type):
        """Sets the task_type of this UpdateTrelloCardTaskParams.


        :param task_type: The task_type of this UpdateTrelloCardTaskParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["update_trello_card"]  # noqa: E501
        if task_type not in allowed_values:
            raise ValueError(
                "Invalid value for `task_type` ({0}), must be one of {1}"  # noqa: E501
                .format(task_type, allowed_values)
            )

        self._task_type = task_type

    @property
    def card_id(self):
        """Gets the card_id of this UpdateTrelloCardTaskParams.  # noqa: E501

        The card id  # noqa: E501

        :return: The card_id of this UpdateTrelloCardTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._card_id

    @card_id.setter
    def card_id(self, card_id):
        """Sets the card_id of this UpdateTrelloCardTaskParams.

        The card id  # noqa: E501

        :param card_id: The card_id of this UpdateTrelloCardTaskParams.  # noqa: E501
        :type: str
        """
        if card_id is None:
            raise ValueError("Invalid value for `card_id`, must not be `None`")  # noqa: E501

        self._card_id = card_id

    @property
    def title(self):
        """Gets the title of this UpdateTrelloCardTaskParams.  # noqa: E501

        The card title  # noqa: E501

        :return: The title of this UpdateTrelloCardTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this UpdateTrelloCardTaskParams.

        The card title  # noqa: E501

        :param title: The title of this UpdateTrelloCardTaskParams.  # noqa: E501
        :type: str
        """

        self._title = title

    @property
    def description(self):
        """Gets the description of this UpdateTrelloCardTaskParams.  # noqa: E501

        The card description  # noqa: E501

        :return: The description of this UpdateTrelloCardTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this UpdateTrelloCardTaskParams.

        The card description  # noqa: E501

        :param description: The description of this UpdateTrelloCardTaskParams.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def due_date(self):
        """Gets the due_date of this UpdateTrelloCardTaskParams.  # noqa: E501

        The due date  # noqa: E501

        :return: The due_date of this UpdateTrelloCardTaskParams.  # noqa: E501
        :rtype: str
        """
        return self._due_date

    @due_date.setter
    def due_date(self, due_date):
        """Sets the due_date of this UpdateTrelloCardTaskParams.

        The due date  # noqa: E501

        :param due_date: The due_date of this UpdateTrelloCardTaskParams.  # noqa: E501
        :type: str
        """

        self._due_date = due_date

    @property
    def board(self):
        """Gets the board of this UpdateTrelloCardTaskParams.  # noqa: E501


        :return: The board of this UpdateTrelloCardTaskParams.  # noqa: E501
        :rtype: CreateTrelloCardTaskParamsBoard
        """
        return self._board

    @board.setter
    def board(self, board):
        """Sets the board of this UpdateTrelloCardTaskParams.


        :param board: The board of this UpdateTrelloCardTaskParams.  # noqa: E501
        :type: CreateTrelloCardTaskParamsBoard
        """

        self._board = board

    @property
    def list(self):
        """Gets the list of this UpdateTrelloCardTaskParams.  # noqa: E501


        :return: The list of this UpdateTrelloCardTaskParams.  # noqa: E501
        :rtype: CreateTrelloCardTaskParamsList
        """
        return self._list

    @list.setter
    def list(self, list):
        """Sets the list of this UpdateTrelloCardTaskParams.


        :param list: The list of this UpdateTrelloCardTaskParams.  # noqa: E501
        :type: CreateTrelloCardTaskParamsList
        """

        self._list = list

    @property
    def labels(self):
        """Gets the labels of this UpdateTrelloCardTaskParams.  # noqa: E501


        :return: The labels of this UpdateTrelloCardTaskParams.  # noqa: E501
        :rtype: list[AddActionItemTaskParamsPostToSlackChannels]
        """
        return self._labels

    @labels.setter
    def labels(self, labels):
        """Sets the labels of this UpdateTrelloCardTaskParams.


        :param labels: The labels of this UpdateTrelloCardTaskParams.  # noqa: E501
        :type: list[AddActionItemTaskParamsPostToSlackChannels]
        """

        self._labels = labels

    @property
    def archivation(self):
        """Gets the archivation of this UpdateTrelloCardTaskParams.  # noqa: E501


        :return: The archivation of this UpdateTrelloCardTaskParams.  # noqa: E501
        :rtype: CreateShortcutStoryTaskParamsArchivation
        """
        return self._archivation

    @archivation.setter
    def archivation(self, archivation):
        """Sets the archivation of this UpdateTrelloCardTaskParams.


        :param archivation: The archivation of this UpdateTrelloCardTaskParams.  # noqa: E501
        :type: CreateShortcutStoryTaskParamsArchivation
        """
        if archivation is None:
            raise ValueError("Invalid value for `archivation`, must not be `None`")  # noqa: E501

        self._archivation = archivation

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateTrelloCardTaskParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateTrelloCardTaskParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
